// AudioCodec.cpp: implementation of the AudioCodec class.
//
//////////////////////////////////////////////////////////////////////

#include "AudioCodec.h"
#ifdef WIN32
#include <windows.h>
#else
#include "cpLog.h"
#define OutputDebugString(x)  cpLog(LOG_DEBUG, x);
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AudioCodec::AudioCodec()
{

}

AudioCodec::~AudioCodec()
{

}

int
AudioCodec::Encode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes)
{
	OutputDebugString("AudioCodec::Encode : ERROR : pure virtual function call !!!\n");
	return 0;
}

int
AudioCodec::Decode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes)
{
	OutputDebugString("AudioCodec::Decode : ERROR : pure virtual function call !!!\n");
	return 0;
}

int
AudioCodec::StartEncoder()
{
	return 0;
}

int
AudioCodec::StartDecoder()
{
	return 0;
}

int
AudioCodec::StopEncoder()
{
	return 0;
}

int
AudioCodec::StopDecoder()
{
	return 0;
}
