// G711Codec.h: interface for the G711Codec class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_G711CODEC_H__E1A6D915_DF7A_4F88_AD8D_C1B927E74630__INCLUDED_
#define AFX_G711CODEC_H__E1A6D915_DF7A_4F88_AD8D_C1B927E74630__INCLUDED_

#include "AudioCodec.h"

enum CodecTypes
{
	CODECTYPE_ULAW = 0,
	CODECTYPE_ALAW = 1
};


class G711Codec : public AudioCodec
{
public:
	G711Codec();
	virtual ~G711Codec();
	int Encode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	int Decode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	int SetULaw() { codecType = 0; return 0; }
	int SetALaw() { codecType = 1; return 0; }
	int GetCodecType() { if (codecType == 1) return CODECTYPE_ALAW; else return CODECTYPE_ULAW; }
private:
	int codecType;	// 0 = ULAW, 1 = ALAW, everything else = ULAW
};

#endif // !defined(AFX_G711CODEC_H__E1A6D915_DF7A_4F88_AD8D_C1B927E74630__INCLUDED_)
