// G723Codec.h: interface for the G723Codec class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_G723CODEC_H__C273C4AC_ABA9_40CA_ADE0_0AA56CFCF4F0__INCLUDED_
#define AFX_G723CODEC_H__C273C4AC_ABA9_40CA_ADE0_0AA56CFCF4F0__INCLUDED_

#include "AudioCodec.h"

enum G723Rates
{
	G723RATE_53 = 0,
	G723RATE_63 = 1
};

class G723Codec : public AudioCodec  
{
public:
	G723Codec();
	virtual ~G723Codec();
	int Encode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	int Decode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	int SetRate53();
	int SetRate63();
	int GetCodecRate();
private:
	char *codecMemory;	// for the G.723_53 codec
	int codecRate;
	int EncoderQuality;
	int DecoderQuality;
};

#endif // !defined(AFX_G723CODEC_H__C273C4AC_ABA9_40CA_ADE0_0AA56CFCF4F0__INCLUDED_)
