// EventSource.h: interface for the EventSource class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_EVENTSOURCE_H__DED9EE79_9D1A_425C_8A37_60D947F141ED__INCLUDED_
#define AFX_EVENTSOURCE_H__DED9EE79_9D1A_425C_8A37_60D947F141ED__INCLUDED_

#ifdef WIN32
#include <windows.h>
#else
#include "VMutex.h"
#endif
#include <vector>

class EventSource  
{
public:
	EventSource();
	virtual ~EventSource();
protected:
	int AddListener(void *listener);
	int RemoveListener(void *listener);
	std::vector<void *> listeners;
#ifdef WIN32
	CRITICAL_SECTION listenersMutex;
#else
	VMutex listenersMutex;
#endif
};

#endif // !defined(AFX_EVENTSOURCE_H__DED9EE79_9D1A_425C_8A37_60D947F141ED__INCLUDED_)
