#include <stdio.h>
#include <stdlib.h>

/* borrowed, adapted, and modifed from the echo.c and echo2.c files
   provided with "Apache - The Definitive Guide" Ben Laurie and
   Peter Laurie */

#define MAX_ENTRIES 10000


char *makeword(char *line, char stop) 
{
    int x = 0,y;
    char *word = (char *) malloc(sizeof(char) * (strlen(line) + 1));

    for(x=0;((line[x]) && (line[x] != stop));x++)
        word[x] = line[x];
    
    word[x] = '\0';
    if(line[x]) ++x;
    y=0;
    
    while(line[y++] = line[x++]);
    return word;
}


char *fmakeword(FILE *f, char stop, int *cl) 
{
    int wsize;
    char *word;
    int ll;
    
    wsize = 102400;
    ll=0;
    word = (char *) malloc(sizeof(char) * (wsize + 1));
    
    while(1) 
    {
        word[ll] = (char)fgetc(f);
        if(ll==wsize) 
        {
            word[ll+1] = '\0';
            wsize+=102400;
            word = (char *)realloc(word,sizeof(char)*(wsize+1));
        }
        --(*cl);
        if((word[ll] == stop) || (feof(f)) || (!(*cl))) 
        {
            if(word[ll] != stop) 
                ll++;
            word[ll] = '\0';
            return word;
        }
        ++ll;
    }
}


char x2c(char *what) 
{
    register char digit;
    
    digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
    digit *= 16;
    digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));
    return(digit);
}


void unescape_url(char *url) 
{
    register int x,y;
    
    for(x=0,y=0;url[y];++x,++y) 
    {
        if((url[x] = url[y]) == '%') 
        {
            url[x] = x2c(&url[y+1]);
            y+=2;
        }
    }
    url[x] = '\0';
}


void plustospace(char *str) 
{
    register int x;
    
    for(x=0;str[x];x++) if(str[x] == '+') str[x] = ' ';
}


typedef struct 
{
    char *name;
    char *val;
} entry;


int main(int argc, char *argv[]) 
{

    FILE *outputfile;
    entry entries[MAX_ENTRIES];
    register int x,m=0;
    int cl;
    char mbuf[200];
    
    printf("Content-type: text/html\n\n");
    
    if(strcmp(getenv("REQUEST_METHOD"),"POST")) 
    {
        printf("This script should be referenced with a METHOD of POST.\n");
        exit(1);
    }
    
    if(strcmp(getenv("CONTENT_TYPE"),
              "application/x-www-form-urlencoded")) 
    {
        printf("This script can only be used to decode form results. \n");
        exit(1);
    }
    
    cl = atoi(getenv("CONTENT_LENGTH"));
    
    if ((outputfile = fopen("forwardfile", "w")) == NULL) {
        printf("Unable to open forward file! \n");
        exit(1);
    }
    
    for(x=0;cl && (!feof(stdin));x++) 
    {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
    }
    
    printf("<html>\n");
    printf("<head>\n");
    printf("<title>Forward Changed\n");
    printf("</title>\n");
    printf("<body bgcolor=\"#ffffff\">\n");
    printf("<body>\n");
    printf("<center><img src=\"../vovida.gif\">\n");
    printf("<H1>Calls Forwarded</H1>");
    printf("Your calls are now forwarded to:<p> "); 
    printf("<h2>%s\n</h2>",entries[0].val);

    fprintf(outputfile, "%s", entries[0].val);
    fclose(outputfile);

    printf("</center>\n");
    printf("</body>\n");
    printf("</html>\n");

}


