
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const ospErrStringsVers = "$Id: OSPErrStrings.cxx,v 1.8 2001/01/30 22:53:52 wbreu Exp $";



#include "cpLog.h"
#include "OSPErrStrings.hxx"


int ospErr[] = {
    OSPC_ERR_NO_ERROR,  //                            0
    OSPC_ERR_OS_FAILURE,  //                          -1
    OSPC_ERR_BAD_SERVICE,  //                         16

    OSPC_ERR_MODULE,  //                              9000
    OSPC_ERR_INVALID_POINTER,  //                     (OSPC_ERR_MODULE + 10)
    OSPC_ERR_TIME_ERROR,  //                          (OSPC_ERR_MODULE + 20)

    OSPC_ERR_PROV_MODULE,  //                         10000
    OSPC_ERR_PROV_INIT_FAILURE,  //                   (OSPC_ERR_PROV_MODULE + 10)
    OSPC_ERR_PROV_NULL_POINTER,  //                   (OSPC_ERR_PROV_MODULE + 20)
    OSPC_ERR_PROV_TRANSCOLLECTION_NOT_FOUND,  //      (OSPC_ERR_PROV_MODULE + 30)
    OSPC_ERR_PROV_NO_PROV_SPACE,  //                  (OSPC_ERR_PROV_MODULE + 40)
    OSPC_ERR_PROV_HANDLE_INVALID,  //                 (OSPC_ERR_PROV_MODULE + 50)
    OSPC_ERR_PROV_MAX_PROVIDERS,  //                  (OSPC_ERR_PROV_MODULE + 60)
    OSPC_ERR_PROV_MUTEX_FAILURE,  //                  (OSPC_ERR_PROV_MODULE + 70)
    OSPC_ERR_PROV_INVALID_VALUE,  //                  (OSPC_ERR_PROV_MODULE + 80)

    OSPC_ERR_TRAN_MODULE,  //                         11000
    OSPC_ERR_TRAN_DELETE_NOT_ALLOWED,  //             (OSPC_ERR_TRAN_MODULE + 10)
    OSPC_ERR_TRAN_TRANSACTION_NOT_FOUND,  //          (OSPC_ERR_TRAN_MODULE + 20)
    OSPC_ERR_TRAN_FIRST_DATA_ALREADY_DELIVERED,  //   (OSPC_ERR_TRAN_MODULE + 30)
    OSPC_ERR_TRAN_RESPONSE_NOT_FOUND,  //             (OSPC_ERR_TRAN_MODULE + 40)
    OSPC_ERR_TRAN_NO_TRANS_SPACE,  //                 (OSPC_ERR_TRAN_MODULE + 50)
    OSPC_ERR_TRAN_MALLOC_FAILED,  //                  (OSPC_ERR_TRAN_MODULE + 60)
    OSPC_ERR_TRAN_TRANSACTION_NOT_ALLOWED,  //        (OSPC_ERR_TRAN_MODULE + 70)
    OSPC_ERR_TRAN_NO_MORE_RESPONSES,  //              (OSPC_ERR_TRAN_MODULE + 80)
    OSPC_ERR_TRAN_VALUE_NOT_FOUND,  //                (OSPC_ERR_TRAN_MODULE + 90)
    OSPC_ERR_TRAN_NOT_ENOUGH_SPACE_FOR_COPY,  //      (OSPC_ERR_TRAN_MODULE + 100)
    OSPC_ERR_TRAN_CALLID_DEST_MISMATCH,  //           (OSPC_ERR_TRAN_MODULE + 110)
    OSPC_ERR_TRAN_INVALID_ENTRY,  //                  (OSPC_ERR_TRAN_MODULE + 120)
    OSPC_ERR_TRAN_TOO_SOON_TO_USE_TOKEN,  //          (OSPC_ERR_TRAN_MODULE + 130)
    OSPC_ERR_TRAN_TOO_LATE_TO_USE_TOKEN,  //          (OSPC_ERR_TRAN_MODULE + 140)
    OSPC_ERR_TRAN_SOURCE_INVALID,  //                 (OSPC_ERR_TRAN_MODULE + 150)
    OSPC_ERR_TRAN_DEST_INVALID,  //                   (OSPC_ERR_TRAN_MODULE + 160)
    OSPC_ERR_TRAN_CALLING_INVALID,  //                (OSPC_ERR_TRAN_MODULE + 170)
    OSPC_ERR_TRAN_CALLED_INVALID,  //                 (OSPC_ERR_TRAN_MODULE + 180)
    OSPC_ERR_TRAN_CALL_ID_INVALID,  //                (OSPC_ERR_TRAN_MODULE + 190)
    OSPC_ERR_TRAN_AUTH_ID_INVALID,  //                (OSPC_ERR_TRAN_MODULE + 200)
    OSPC_ERR_TRAN_CALLID_NOT_FOUND,  //               (OSPC_ERR_TRAN_MODULE + 210)
    OSPC_ERR_TRAN_NUMBER_CALL_IDS_INVALID,  //        (OSPC_ERR_TRAN_MODULE + 220)
    OSPC_ERR_TRAN_NOT_IMPLEMENTED,  //                (OSPC_ERR_TRAN_MODULE + 230)
    OSPC_ERR_TRAN_HANDLE_INVALID,  //                 (OSPC_ERR_TRAN_MODULE + 240)
    OSPC_ERR_TRAN_INVALID_FAILURE_CODE,  //           (OSPC_ERR_TRAN_MODULE + 250)
    OSPC_ERR_TRAN_STATUS_INVALID,  //                 (OSPC_ERR_TRAN_MODULE + 260)
    OSPC_ERR_TRAN_TOKEN_INVALID,  //                  (OSPC_ERR_TRAN_MODULE + 270)
    OSPC_ERR_TRAN_STATUS_NOT_FOUND,  //               (OSPC_ERR_TRAN_MODULE + 280)
    OSPC_ERR_TRAN_VALID_AFTER_NOT_FOUND,  //          (OSPC_ERR_TRAN_MODULE + 290)
    OSPC_ERR_TRAN_DEST_NOT_FOUND,  //                 (OSPC_ERR_TRAN_MODULE + 300)
    OSPC_ERR_TRAN_VALID_UNTIL_NOT_FOUND,  //          (OSPC_ERR_TRAN_MODULE + 310)
    OSPC_ERR_TRAN_SIGADDR_INVALID,  //                (OSPC_ERR_TRAN_MODULE + 320)
    OSPC_ERR_TRAN_TXID_NOT_FOUND,  //                 (OSPC_ERR_TRAN_MODULE + 330)
    OSPC_ERR_TRAN_SOURCE_NUMBER_NOT_FOUND,  //        (OSPC_ERR_TRAN_MODULE + 340)
    OSPC_ERR_TRAN_DEST_NUMBER_NOT_FOUND,  //          (OSPC_ERR_TRAN_MODULE + 350)
    OSPC_ERR_TRAN_TOKEN_NOT_FOUND,  //                (OSPC_ERR_TRAN_MODULE + 360)
    OSPC_ERR_TRAN_LIST_NOT_FOUND,  //                 (OSPC_ERR_TRAN_MODULE + 370)
    OSPC_ERR_TRAN_ACCUMULATE_NOT_ALLOWED,  //         (OSPC_ERR_TRAN_MODULE + 380)
    OSPC_ERR_TRAN_USAGE_ALREADY_REPORTED,  //         (OSPC_ERR_TRAN_MODULE + 390)
    OSPC_ERR_TRAN_STATS_NOT_FOUND,  //                (OSPC_ERR_TRAN_MODULE + 400)
    OSPC_ERR_TRAN_STATS_NEW_FAIL,  //                 (OSPC_ERR_TRAN_MODULE + 410)
    OSPC_ERR_TRAN_INVALID_CALC,  //                   (OSPC_ERR_TRAN_MODULE + 420)
    OSPC_ERR_TRAN_GET_DEST_NOT_ALLOWED,  //           (OSPC_ERR_TRAN_MODULE + 430)
    OSPC_ERR_TRAN_AUTH_REQ_NOT_FOUND,  //             (OSPC_ERR_TRAN_MODULE + 440)
    OSPC_ERR_TRAN_TXID_INVALID,  //                   (OSPC_ERR_TRAN_MODULE + 450)
    OSPC_ERR_TRAN_DATA_NOT_FOUND,  //                 (OSPC_ERR_TRAN_MODULE + 460)
    OSPC_ERR_TRAN_NO_NEW_AUTHREQ,  //                 (OSPC_ERR_TRAN_MODULE + 470)
    OSPC_ERR_TRAN_TOKEN_REUSE,  //                    (OSPC_ERR_TRAN_MODULE + 480)

    OSPC_ERR_TRAN_CLIENT_ERROR,  //                   (OSPC_ERR_TRAN_MODULE + 481)
    OSPC_ERR_TRAN_BAD_REQUEST,  //                    (OSPC_ERR_TRAN_MODULE + 482)
    OSPC_ERR_TRAN_UNAUTHORIZED,  //                   (OSPC_ERR_TRAN_MODULE + 483)
    OSPC_ERR_TRAN_CHAR_ENC_NOT_SUPD,  //              (OSPC_ERR_TRAN_MODULE + 484)
    OSPC_ERR_TRAN_PARS_UNSUCCESSFUL,  //              (OSPC_ERR_TRAN_MODULE + 485)
    OSPC_ERR_TRAN_UNSUPD_CRIT_ELEM,  //               (OSPC_ERR_TRAN_MODULE + 486)
    OSPC_ERR_TRAN_SECURITY_PROBLEM,  //               (OSPC_ERR_TRAN_MODULE + 487)
    OSPC_ERR_TRAN_SIG_INVALID,  //                    (OSPC_ERR_TRAN_MODULE + 488)
    OSPC_ERR_TRAN_CRYPTO_ALG_NOT_SUPD,  //            (OSPC_ERR_TRAN_MODULE + 489)
    OSPC_ERR_TRAN_CERT_INVALID,  //                   (OSPC_ERR_TRAN_MODULE + 490)
    OSPC_ERR_TRAN_CERT_REVOKED,  //                   (OSPC_ERR_TRAN_MODULE + 491)
    OSPC_ERR_TRAN_ENCRYPTION_REQD,  //                (OSPC_ERR_TRAN_MODULE + 492)
    OSPC_ERR_TRAN_SERVER_ERROR,  //                   (OSPC_ERR_TRAN_MODULE + 493)
    OSPC_ERR_TRAN_INTERNAL_SRVR_ERR,  //              (OSPC_ERR_TRAN_MODULE + 494)
    OSPC_ERR_TRAN_UNIMPLEMENTED,  //                  (OSPC_ERR_TRAN_MODULE + 495)
    OSPC_ERR_TRAN_SERVICE_NOT_AVAIL,  //              (OSPC_ERR_TRAN_MODULE + 496)
    OSPC_ERR_TRAN_TRANSIENT_SRVR_PROB,  //            (OSPC_ERR_TRAN_MODULE + 497)
    OSPC_ERR_TRAN_LONG_TERM_SRVR_PROB,  //            (OSPC_ERR_TRAN_MODULE + 498)
    OSPC_ERR_TRAN_TIME_PROB,  //                      (OSPC_ERR_TRAN_MODULE + 499)
    OSPC_ERR_TRAN_VALID_TIME_TOO_SOON,  //            (OSPC_ERR_TRAN_MODULE + 500)
    OSPC_ERR_TRAN_TIME_INTERVAL_TOO_SMALL,  //        (OSPC_ERR_TRAN_MODULE + 501)
    OSPC_ERR_TRAN_GENERIC_FAILURE,  //                (OSPC_ERR_TRAN_MODULE + 502)

    OSPC_ERR_SEC_MODULE,  //                          12000
    OSPC_ERR_SEC_NOT_ENOUGH_SPACE_FOR_COPY,  //       (OSPC_ERR_SEC_MODULE + 10)
    OSPC_ERR_SEC_INVALID_ARG,  //                     (OSPC_ERR_SEC_MODULE + 20)
    OSPC_ERR_SEC_PRIVATE_KEY_NOT_FOUND,  //           (OSPC_ERR_SEC_MODULE + 30)
    OSPC_ERR_SEC_NOT_IMPLEMENTED,  //                 (OSPC_ERR_SEC_MODULE + 40)
    OSPC_ERR_SEC_NO_MEMORY,  //                       (OSPC_ERR_SEC_MODULE + 50)
    OSPC_ERR_SEC_INVALID_SIG,  //                     (OSPC_ERR_SEC_MODULE + 60)
    OSPC_ERR_SEC_SSL_INIT_DB_FAILED,  //              (OSPC_ERR_SEC_MODULE + 65)
    OSPC_ERR_SEC_NO_SPACE_FOR_CERTIFICATE,  //        (OSPC_ERR_SEC_MODULE + 70)
    OSPC_ERR_SEC_LOCAL_CERTINFO_UNDEFINED,  //        (OSPC_ERR_SEC_MODULE + 80)
    OSPC_ERR_SEC_ZERO_LENGTH_CERTIFICATE,  //         (OSPC_ERR_SEC_MODULE + 90)
    OSPC_ERR_SEC_CERTIFICATE_TOO_BIG,  //             (OSPC_ERR_SEC_MODULE + 100)
    OSPC_ERR_SEC_INVALID_CERTIFICATE,  //             (OSPC_ERR_SEC_MODULE + 110)
    OSPC_ERR_SEC_NULL_CERTIFICATE,  //                (OSPC_ERR_SEC_MODULE + 120)
    OSPC_ERR_SEC_TOO_MANY_CERTIFICATES,  //           (OSPC_ERR_SEC_MODULE + 130)
    OSPC_ERR_SEC_NO_STORAGE_PROVIDED,  //             (OSPC_ERR_SEC_MODULE + 140)
    OSPC_ERR_SEC_NO_PRIVATE_KEY,  //                  (OSPC_ERR_SEC_MODULE + 150)
    OSPC_ERR_SEC_INVALID_CONTEXT,  //                 (OSPC_ERR_SEC_MODULE + 160)
    OSPC_ERR_SEC_UNABLE_TO_ALLOCATE_SPACE,  //        (OSPC_ERR_SEC_MODULE + 170)
    OSPC_ERR_SEC_CA_CERTIFICATES_DONT_MATCH,  //      (OSPC_ERR_SEC_MODULE + 180)
    OSPC_ERR_SEC_NO_AUTHORITY_CERTIFICATES,  //       (OSPC_ERR_SEC_MODULE + 190)
    OSPC_ERR_SEC_CACERT_INDEX_OVERFLOW,  //       (OSPC_ERR_SEC_MODULE + 200)

    OSPC_ERR_MSG_MODULE,  //                          13000
    OSPC_ERR_MIME_BUFFER_TOO_SMALL,  //               (OSPC_ERR_MSG_MODULE + 110)
    OSPC_ERR_MIME_MALLOC_FAILED,  //                  (OSPC_ERR_MSG_MODULE + 115)
    OSPC_ERR_MIME_VAR_NOT_FOUND,  //                  (OSPC_ERR_MSG_MODULE + 120)
    OSPC_ERR_MIME_NO_INPUT,  //                       (OSPC_ERR_MSG_MODULE + 125)
    OSPC_ERR_MIME_INVALID_ARG ,  //                   (OSPC_ERR_MSG_MODULE + 130)
    OSPC_ERR_MIME_NO_MORE_SPACE,  //                  (OSPC_ERR_MSG_MODULE + 135)
    OSPC_ERR_MIME_INVALID_TYPE,  //                   (OSPC_ERR_MSG_MODULE + 140)
    OSPC_ERR_MIME_INVALID_SUBTYPE,  //                (OSPC_ERR_MSG_MODULE + 145)
    OSPC_ERR_MIME_PROTOCOL_NOT_FOUND,  //             (OSPC_ERR_MSG_MODULE + 150)
    OSPC_ERR_MIME_MICALG_NOT_FOUND,  //               (OSPC_ERR_MSG_MODULE + 155)
    OSPC_ERR_MIME_BOUNDARY_NOT_FOUND,  //             (OSPC_ERR_MSG_MODULE + 160)
    OSPC_ERR_MIME_CONTENT_TYPE_NOT_FOUND,  //         (OSPC_ERR_MSG_MODULE + 165)
    OSPC_ERR_MIME_MSG_PARTS_NOT_FOUND,  //            (OSPC_ERR_MSG_MODULE + 170)

    OSPC_ERR_XML_INCOMPLETE,  //                      (OSPC_ERR_MSG_MODULE + 301)
    OSPC_ERR_XML_BAD_ENC,  //                         (OSPC_ERR_MSG_MODULE + 302)
    OSPC_ERR_XML_BAD_ENTITY,  //                      (OSPC_ERR_MSG_MODULE + 303)
    OSPC_ERR_XML_BAD_NAME,  //                        (OSPC_ERR_MSG_MODULE + 304)
    OSPC_ERR_XML_BAD_TAG,  //                         (OSPC_ERR_MSG_MODULE + 305)
    OSPC_ERR_XML_BAD_ATTR,  //                        (OSPC_ERR_MSG_MODULE + 306)
    OSPC_ERR_XML_BADCID_ENC,  //                      (OSPC_ERR_MSG_MODULE + 307)
    OSPC_ERR_XML_BAD_ELEMENT,  //                     (OSPC_ERR_MSG_MODULE + 308)
    OSPC_ERR_XML_NO_ELEMENT,  //                      (OSPC_ERR_MSG_MODULE + 309)
    OSPC_ERR_XML_NO_ATTR,  //                         (OSPC_ERR_MSG_MODULE + 310)
    OSPC_ERR_XML_INVALID_ARGS,  //                    (OSPC_ERR_MSG_MODULE + 311)
    OSPC_ERR_XML_BUFR_NEW_FAILED,  //                 (OSPC_ERR_MSG_MODULE + 312)
    OSPC_ERR_XML_BFR_SZ_FAIL,  //                     (OSPC_ERR_MSG_MODULE + 313)
    OSPC_ERR_XML_BFR_READ_BLOCK_FAIL,  //             (OSPC_ERR_MSG_MODULE + 314)
    OSPC_ERR_XML_MALLOC_FAILED,  //                   (OSPC_ERR_MSG_MODULE + 315)
    OSPC_ERR_XML_INVALID_TYPE,  //                    (OSPC_ERR_MSG_MODULE + 316)
    OSPC_ERR_XML_PARENT_NOT_FOUND,  //                (OSPC_ERR_MSG_MODULE + 317)
    OSPC_ERR_XML_CHILD_NOT_FOUND,  //                 (OSPC_ERR_MSG_MODULE + 318)
    OSPC_ERR_XML_DATA_TYPE_NOT_FOUND,  //             (OSPC_ERR_MSG_MODULE + 319)
    OSPC_ERR_XML_BFR_WRITE_BLOCK_FAILED,  //          (OSPC_ERR_MSG_MODULE + 320)

    OSPC_ERR_DATA_NOCALLID,  //                       (OSPC_ERR_MSG_MODULE + 410)
    OSPC_ERR_DATA_NO_TOKEN,  //                       (OSPC_ERR_MSG_MODULE + 415)
    OSPC_ERR_DATA_BAD_NUMBER,  //                     (OSPC_ERR_MSG_MODULE + 420)
    OSPC_ERR_DATA_NO_DEST,  //                        (OSPC_ERR_MSG_MODULE + 425)
    OSPC_ERR_DATA_NO_USAGEIND,  //                    (OSPC_ERR_MSG_MODULE + 430)
    OSPC_ERR_DATA_NO_STATUS,  //                      (OSPC_ERR_MSG_MODULE + 435)
    OSPC_ERR_DATA_NO_USAGECNF,  //                    (OSPC_ERR_MSG_MODULE + 440)
    OSPC_ERR_DATA_NO_AUTHIND,  //                     (OSPC_ERR_MSG_MODULE + 445)
    OSPC_ERR_DATA_NO_AUTHREQ,  //                     (OSPC_ERR_MSG_MODULE + 450)
    OSPC_ERR_DATA_NO_AUTHRSP,  //                     (OSPC_ERR_MSG_MODULE + 455)
    OSPC_ERR_DATA_NO_AUTHCNF,  //                     (OSPC_ERR_MSG_MODULE + 460)
    OSPC_ERR_DATA_NO_REAUTHREQ,  //                   (OSPC_ERR_MSG_MODULE + 465)
    OSPC_ERR_DATA_NO_REAUTHRSP,  //                   (OSPC_ERR_MSG_MODULE + 470)
    OSPC_ERR_DATA_INVALID_TYPE,  //                   (OSPC_ERR_MSG_MODULE + 475)
    OSPC_ERR_DATA_NO_USAGE,  //                       (OSPC_ERR_MSG_MODULE + 480)
    OSPC_ERR_DATA_NO_TOKENINFO,  //                   (OSPC_ERR_MSG_MODULE + 485)
    OSPC_ERR_DATA_INVALID,  //                        (OSPC_ERR_MSG_MODULE + 490)
    OSPC_ERR_DATA_NO_ALTINFO,  //                     (OSPC_ERR_MSG_MODULE + 500)
    OSPC_ERR_DATA_NO_STATS,  //                       (OSPC_ERR_MSG_MODULE + 510)
    OSPC_ERR_DATA_NO_DELAY,  //                       (OSPC_ERR_MSG_MODULE + 520)

    OSPC_ERR_CERT_MALLOC_FAILED,  //                  (OSPC_ERR_MSG_MODULE + 610)

    OSPC_ERR_COMM_MODULE,  //                         14000
    OSPC_ERR_COMM_INVALID_SIZE,  //                   (OSPC_ERR_COMM_MODULE + 10)
    OSPC_ERR_COMM_BAD_VALUE,  //                      (OSPC_ERR_COMM_MODULE + 20)
    OSPC_ERR_COMM_PARSER,  //                         (OSPC_ERR_COMM_MODULE + 30)
    OSPC_ERR_COMM_NO_MEMORY,  //                      (OSPC_ERR_COMM_MODULE + 40)
    OSPC_ERR_COMM_INUSE,  //                          (OSPC_ERR_COMM_MODULE + 50)
    OSPC_ERR_COMM_INVALID_ARG,  //                    (OSPC_ERR_COMM_MODULE + 60)
    OSPC_ERR_COMM_NO_SVC_PTS,  //                     (OSPC_ERR_COMM_MODULE + 70)
    OSPC_ERR_COMM_NO_SVC_PTS_AVAIL,  //               (OSPC_ERR_COMM_MODULE + 80)
    OSPC_ERR_COMM_THREAD_INIT_FAILED,  //             (OSPC_ERR_COMM_MODULE + 85)

    OSPC_ERR_MSGQ_NO_MEMORY,  //                      (OSPC_ERR_COMM_MODULE + 110)

    OSPC_ERR_HTTP_BAD_HEADER_100,  //                 (OSPC_ERR_COMM_MODULE + 210)
    OSPC_ERR_HTTP_BAD_HEADER_200,  //                 (OSPC_ERR_COMM_MODULE + 220)
    OSPC_ERR_HTTP_BAD_QUEUE,  //                      (OSPC_ERR_COMM_MODULE + 230)
    OSPC_ERR_HTTP_BAD_MESSAGE,  //                    (OSPC_ERR_COMM_MODULE + 240)
    OSPC_ERR_HTTP_INVALID_ARG,  //                    (OSPC_ERR_COMM_MODULE + 250)
    OSPC_ERR_HTTP_MALLOC_FAILED,  //                  (OSPC_ERR_COMM_MODULE + 260)
    OSPC_ERR_HTTP_NEWCONN_FAILED,  //                 (OSPC_ERR_COMM_MODULE + 270)
    OSPC_ERR_HTTP_SERVER_ERROR,  //                   (OSPC_ERR_COMM_MODULE + 280)
    OSPC_ERR_HTTP_SHUTDOWN,  //                       (OSPC_ERR_COMM_MODULE + 290)
    OSPC_ERR_HTTP_SSL_NEW_FAILED,  //                 (OSPC_ERR_COMM_MODULE + 292)
    OSPC_ERR_HTTP_SSL_CTX_NEW_FAILED,  //             (OSPC_ERR_COMM_MODULE + 295)
    OSPC_ERR_HTTP_SERVICE_UNAVAILABLE,  //            (OSPC_ERR_COMM_MODULE + 297)

    OSPC_ERR_SOCK_SELECT_FAILED,  //                  (OSPC_ERR_COMM_MODULE + 300)
    OSPC_ERR_SOCK_RECV_FAILED,  //                    (OSPC_ERR_COMM_MODULE + 310)
    OSPC_ERR_SOCK_SEND_FAILED,  //                    (OSPC_ERR_COMM_MODULE + 315)
    OSPC_ERR_SOCK_RECVBUF_MALLOC_FAILED,  //          (OSPC_ERR_COMM_MODULE + 320)
    OSPC_ERR_SOCK_RESET,  //                          (OSPC_ERR_COMM_MODULE + 321)
    OSPC_ERR_SOCK_CREATE_FAILED,  //                  (OSPC_ERR_COMM_MODULE + 330)
    OSPC_ERR_SOCK_CLOSE_FAILED,  //                   (OSPC_ERR_COMM_MODULE + 340)
    OSPC_ERR_SOCK_CONNECT_FAILED,  //                 (OSPC_ERR_COMM_MODULE + 350)
    OSPC_ERR_SOCK_BLOCKIO_FAILED,  //                 (OSPC_ERR_COMM_MODULE + 360)
    OSPC_ERR_SOCK_DISABLE_NAGLE_FAILED,  //           (OSPC_ERR_COMM_MODULE + 370)
    OSPC_ERR_SOCK_CONN_IN_PROGRESS,  //               (OSPC_ERR_COMM_MODULE + 380)

    OSPC_ERR_SSL_MALLOC_FAILED,  //                   (OSPC_ERR_COMM_MODULE + 400)
    OSPC_ERR_SSL_INIT_CTX_FAILED,  //                 (OSPC_ERR_COMM_MODULE + 410)
    OSPC_ERR_SSL_VERSION_FAILED,  //                  (OSPC_ERR_COMM_MODULE + 420)
    OSPC_ERR_SSL_INIT_SESSION_FAILED,  //             (OSPC_ERR_COMM_MODULE + 430)
    OSPC_ERR_SSL_ATTACH_SOCK_FAILED,  //              (OSPC_ERR_COMM_MODULE + 440)
    OSPC_ERR_SSL_HANDSHAKE_FAILED,  //                (OSPC_ERR_COMM_MODULE + 450)
    OSPC_ERR_SSL_CLOSE_FAILED,  //                    (OSPC_ERR_COMM_MODULE + 460)
    OSPC_ERR_SSL_READ_FAILED,  //                     (OSPC_ERR_COMM_MODULE + 470)
    OSPC_ERR_SSL_WRITE_FAILED,  //                    (OSPC_ERR_COMM_MODULE + 480)
    OSPC_ERR_SSL_GETCERT_FAILED,  //                  (OSPC_ERR_COMM_MODULE + 490)
    OSPC_ERR_SSL_NO_ROOT_CA,  //                      (OSPC_ERR_COMM_MODULE + 495)
    OSPC_ERR_SSL_SET_PRIVKEY_FAILED,  //              (OSPC_ERR_COMM_MODULE + 496)
    OSPC_ERR_SSL_PARSE_PRIVKEY_FAILED,  //            (OSPC_ERR_COMM_MODULE + 497)
    OSPC_ERR_SSL_ADD_CERTS_FAILED,  //                (OSPC_ERR_COMM_MODULE + 498)
    OSPC_ERR_SSL_ADD_DN_FAILED,  //                   (OSPC_ERR_COMM_MODULE + 499)

    OSPC_ERR_UTIL_MODULE,  //                         15400
    OSPC_ERR_UTIL_NOT_ENOUGH_SPACE_FOR_COPY,  //      (OSPC_ERR_UTIL_MODULE + 10)
    OSPC_ERR_UTIL_NO_TIME_STAMP_CREATED,  //          (OSPC_ERR_UTIL_MODULE + 20)
    OSPC_ERR_UTIL_VALUE_NOT_FOUND,  //                (OSPC_ERR_UTIL_MODULE + 30)
    OSPC_ERR_UTIL_MALLOC_FAILED,  //                  (OSPC_ERR_UTIL_MODULE + 40)
    OSPC_ERR_UTIL_INVALID_ARG,  //                    (OSPC_ERR_UTIL_MODULE + 50)

    OSPC_ERR_BUF_EMPTY,  //                           (OSPC_ERR_UTIL_MODULE + 100)
    OSPC_ERR_BUF_INCOMPLETE,  //                      (OSPC_ERR_UTIL_MODULE + 110)


    OSPC_ERR_FAILRSN_MODULE,  //                      15600
    OSPC_ERR_FAILRSN_NO_DATA,  //                     (OSPC_ERR_FAILRSN_MODULE + 10)
    OSPC_ERR_FAILRSN_INVALID,  //                     (OSPC_ERR_FAILRSN_MODULE + 20)

    OSPC_ERR_POW,  //                                 15980
    OSPC_ERR_OS_CONDVAR_TIMEOUT,  //                  15990

    OSPC_ERR_X509_MODULE,  //                         16000
    OSPC_ERR_X509_SERIAL_NUMBER_UNDEFINED,  //        (OSPC_ERR_X509_MODULE + 10)
    OSPC_ERR_X509_CERTIFICATE_UNDEFINED,  //          (OSPC_ERR_X509_MODULE + 20)
    OSPC_ERR_X509_INVALID_CONTEXT,  //                (OSPC_ERR_X509_MODULE + 30)
    OSPC_ERR_X509_DECODING_ERROR,  //                 (OSPC_ERR_X509_MODULE + 40)
    OSPC_ERR_X509_UNABLE_TO_ALLOCATE_SPACE,  //       (OSPC_ERR_X509_MODULE + 50)
    OSPC_ERR_X509_INVALID_DATE,  //                   (OSPC_ERR_X509_MODULE + 60)
    OSPC_ERR_X509_CERTIFICATE_EXPIRED,  //            (OSPC_ERR_X509_MODULE + 70)
    OSPC_ERR_X509_CA_NOT_FOUND,  //                   (OSPC_ERR_X509_MODULE + 80)

    OSPC_ERR_PKCS1_MODULE,  //                        17000
    OSPC_ERR_PKCS1_INVALID_PRIVATE_KEY_POINTER,  //   (OSPC_ERR_PKCS1_MODULE + 10)
    OSPC_ERR_PKCS1_UNABLE_TO_ALLOCATE_SPACE,  //      (OSPC_ERR_PKCS1_MODULE + 20)
    OSPC_ERR_PKCS1_INVALID_CONTEXT,  //               (OSPC_ERR_PKCS1_MODULE + 30)
    OSPC_ERR_PKCS1_NULL_POINTER,  //                  (OSPC_ERR_PKCS1_MODULE + 40)
    OSPC_ERR_PKCS1_PRIVATE_KEY_OVERFLOW,  //          (OSPC_ERR_PKCS1_MODULE + 50)

    OSPC_ERR_PKCS7_MODULE,  //                        18000
    OSPC_ERR_PKCS7_SIGNER_MISSING,  //                (OSPC_ERR_PKCS7_MODULE + 10)
    OSPC_ERR_PKCS7_INVALID_SIGNATURE,  //             (OSPC_ERR_PKCS7_MODULE + 20)
    OSPC_ERR_PKCS7_UNABLE_TO_ALLOCATE_SPACE,  //      (OSPC_ERR_PKCS7_MODULE + 21)
    OSPC_ERR_PKCS7_ENCODING_ERROR,  //                (OSPC_ERR_PKCS7_MODULE + 30)
    OSPC_ERR_PKCS7_INVALID_POINTER,  //               (OSPC_ERR_PKCS7_MODULE + 40)
    OSPC_ERR_PKCS7_BUFFER_OVERFLOW,  //               (OSPC_ERR_PKCS7_MODULE + 50)

    OSPC_ERR_ASN1_MODULE,  //                         19000
    OSPC_ERR_ASN1_NULL_POINTER,  //                   (OSPC_ERR_ASN1_MODULE + 10)
    OSPC_ERR_ASN1_INVALID_ELEMENT_TAG,  //            (OSPC_ERR_ASN1_MODULE + 20)
    OSPC_ERR_ASN1_UNEXPECTED_HIGH_TAG,  //            (OSPC_ERR_ASN1_MODULE + 30)
    OSPC_ERR_ASN1_INVALID_PRIMITIVE_TAG,  //          (OSPC_ERR_ASN1_MODULE + 40)
    OSPC_ERR_ASN1_UNABLE_TO_ALLOCATE_SPACE,  //       (OSPC_ERR_ASN1_MODULE + 50)
    OSPC_ERR_ASN1_INVALID_CONTEXT,  //                (OSPC_ERR_ASN1_MODULE + 60)
    OSPC_ERR_ASN1_INVALID_TIME,  //                   (OSPC_ERR_ASN1_MODULE + 70)
    OSPC_ERR_ASN1_PARSE_ERROR,  //                    (OSPC_ERR_ASN1_MODULE + 80)
    OSPC_ERR_ASN1_PARSE_COMPLETE,  //                 (OSPC_ERR_ASN1_MODULE + 90)
    OSPC_ERR_ASN1_PARSE_DEFAULTED,  //                (OSPC_ERR_ASN1_MODULE +100)
    OSPC_ERR_ASN1_LENGTH_OVERFLOW,  //                (OSPC_ERR_ASN1_MODULE +110)
    OSPC_ERR_ASN1_UNSUPPORTED_TAG,  //                (OSPC_ERR_ASN1_MODULE +120)
    OSPC_ERR_ASN1_OBJECTID_NOT_FOUND,  //             (OSPC_ERR_ASN1_MODULE +130)
    OSPC_ERR_ASN1_OBJECTID_MISMATCH,  //              (OSPC_ERR_ASN1_MODULE +140)
    OSPC_ERR_ASN1_UNEXPECTED_INT_BASE,  //            (OSPC_ERR_ASN1_MODULE +150)
    OSPC_ERR_ASN1_BUFFER_OVERFLOW,  //                (OSPC_ERR_ASN1_MODULE +160)
    OSPC_ERR_ASN1_INVALID_DATAREFID,  //              (OSPC_ERR_ASN1_MODULE +170)
    OSPC_ERR_ASN1_NO_CONTENT_VALUE_FOR_ELEMENT,  //   (OSPC_ERR_ASN1_MODULE +180)
    OSPC_ERR_ASN1_INTEGER_OVERFLOW,  //               (OSPC_ERR_ASN1_MODULE +190)

    OSPC_ERR_CRYPTO_MODULE,  //                   20000
    OSPC_ERR_CRYPTO_INVALID_PARAMETERS,  //       (OSPC_ERR_CRYPTO_MODULE + 10)
    OSPC_ERR_CRYPTO_UNABLE_TO_ALLOCATE_SPACE,  // (OSPC_ERR_CRYPTO_MODULE + 20)
    OSPC_ERR_CRYPTO_SIGNATURE_DID_NOT_VERIFY ,  // OSPC_ERR_CRYPTO_MODULE + 30)
    OSPC_ERR_CRYPTO_IMPLEMENTATION_SPECIFIC_ERROR,  // (OSPC_ERR_CRYPTO_MODULE + 40)
    OSPC_ERR_CRYPTO_INVALID_POINTER,  //         (OSPC_ERR_CRYPTO_MODULE + 50)
    OSPC_ERR_CRYPTO_NOT_ENOUGH_SPACE,  //        (OSPC_ERR_CRYPTO_MODULE + 60)

    OSPC_ERR_PKCS8_MODULE,  //                       21000
    OSPC_ERR_PKCS8_INVALID_PRIVATE_KEY_POINTER,  //  (OSPC_ERR_PKCS1_MODULE + 10)
    OSPC_ERR_PKCS8_UNABLE_TO_ALLOCATE_SPACE,  //     (OSPC_ERR_PKCS1_MODULE + 20)
    OSPC_ERR_PKCS8_INVALID_CONTEXT,  //              (OSPC_ERR_PKCS1_MODULE + 30)
    OSPC_ERR_PKCS8_NULL_POINTER,  //                 (OSPC_ERR_PKCS1_MODULE + 40)
    OSPC_ERR_PKCS8_PRIVATE_KEY_OVERFLOW,  //         (OSPC_ERR_PKCS1_MODULE + 50)

    OSPC_ERR_B64_MODULE,  //                         (22000)
    OSPC_ERR_B64_ENCODE_FAILED,  //                  (OSPC_ERR_B64_MODULE+10)
    OSPC_ERR_B64_DECODE_FAILED,  //                  (OSPC_ERR_B64_MODULE+20)

    OSPC_ERR_AUDIT_MODULE,  //                       22500
    OSPC_ERR_AUDIT_MALLOC_FAILED,  //                (OSPC_ERR_AUDIT_MODULE+10)
    OSPC_ERR_AUDIT_NOT_FOUND,  //                    (OSPC_ERR_AUDIT_MODULE+20)
    OSPC_ERR_AUDIT_THREAD_INIT_FAILED,  //           (OSPC_ERR_AUDIT_MODULE+30)
    OSPC_ERR_AUDIT_DUMP_FAILED,  //                  (OSPC_ERR_AUDIT_MODULE+40)

    OSPC_ERR_TRANSID_MODULE,  //                     23000
    OSPC_ERR_TRANSID         //                     (OSPC_ERR_TRANSID_MODULE + 10)
};

/// Corresponding string name for ospErr[]
string OSPErrString[] = {
    " OSPC_ERR_NO_ERROR ",
    " OSPC_ERR_OS_FAILURE",
    " OSPC_ERR_BAD_SERVIC",
    " OSPC_ERR_MODULE",
    " OSPC_ERR_INVALID_POINTER ",
    " OSPC_ERR_TIME_ERROR ",
    " OSPC_ERR_PROV_MODULE",
    " OSPC_ERR_PROV_INIT_FAILURE ",
    " OSPC_ERR_PROV_NULL_POINTER ",
    " OSPC_ERR_PROV_TRANSCOLLECTION_NOT_FOUND ",
    " OSPC_ERR_PROV_NO_PROV_SPACE          ",
    " OSPC_ERR_PROV_HANDLE_INVALID         ",
    " OSPC_ERR_PROV_MAX_PROVIDERS          ",
    " OSPC_ERR_PROV_MUTEX_FAILURE          ",
    " OSPC_ERR_PROV_INVALID_VALUE          ",
    " OSPC_ERR_TRAN_MODULE",
    " OSPC_ERR_TRAN_DELETE_NOT_ALLOWED     ",
    " OSPC_ERR_TRAN_TRANSACTION_NOT_FOUND  ",
    " OSPC_ERR_TRAN_FIRST_DATA_ALREADY_DELIVERED ",
    " OSPC_ERR_TRAN_RESPONSE_NOT_FOUND     ",
    " OSPC_ERR_TRAN_NO_TRANS_SPACE         ",
    " OSPC_ERR_TRAN_MALLOC_FAILED          ",
    " OSPC_ERR_TRAN_TRANSACTION_NOT_ALLOWED      ",
    " OSPC_ERR_TRAN_NO_MORE_RESPONSES      ",
    " OSPC_ERR_TRAN_VALUE_NOT_FOUND        ",
    " OSPC_ERR_TRAN_NOT_ENOUGH_SPACE_FOR_COPY    ",
    " OSPC_ERR_TRAN_CALLID_DEST_MISMATCH   ",
    " OSPC_ERR_TRAN_INVALID_ENTRY          ",
    " OSPC_ERR_TRAN_TOO_SOON_TO_USE_TOKEN  ",
    " OSPC_ERR_TRAN_TOO_LATE_TO_USE_TOKEN  ",
    " OSPC_ERR_TRAN_SOURCE_INVALID         ",
    " OSPC_ERR_TRAN_DEST_INVALID           ",
    " OSPC_ERR_TRAN_CALLING_INVALID        ",
    " OSPC_ERR_TRAN_CALLED_INVALID         ",
    " OSPC_ERR_TRAN_CALL_ID_INVALID        ",
    " OSPC_ERR_TRAN_AUTH_ID_INVALID        ",
    " OSPC_ERR_TRAN_CALLID_NOT_FOUND       ",
    " OSPC_ERR_TRAN_NUMBER_CALL_IDS_INVALID      ",
    " OSPC_ERR_TRAN_NOT_IMPLEMENTED        ",
    " OSPC_ERR_TRAN_HANDLE_INVALID         ",
    " OSPC_ERR_TRAN_INVALID_FAILURE_CODE   ",
    " OSPC_ERR_TRAN_STATUS_INVALID         ",
    " OSPC_ERR_TRAN_TOKEN_INVALID          ",
    " OSPC_ERR_TRAN_STATUS_NOT_FOUND       ",
    " OSPC_ERR_TRAN_VALID_AFTER_NOT_FOUND  ",
    " OSPC_ERR_TRAN_DEST_NOT_FOUND         ",
    " OSPC_ERR_TRAN_VALID_UNTIL_NOT_FOUND  ",
    " OSPC_ERR_TRAN_SIGADDR_INVALID        ",
    " OSPC_ERR_TRAN_TXID_NOT_FOUND         ",
    " OSPC_ERR_TRAN_SOURCE_NUMBER_NOT_FOUND      ",
    " OSPC_ERR_TRAN_DEST_NUMBER_NOT_FOUND  ",
    " OSPC_ERR_TRAN_TOKEN_NOT_FOUND        ",
    " OSPC_ERR_TRAN_LIST_NOT_FOUND         ",
    " OSPC_ERR_TRAN_ACCUMULATE_NOT_ALLOWED ",
    " OSPC_ERR_TRAN_USAGE_ALREADY_REPORTED ",
    " OSPC_ERR_TRAN_STATS_NOT_FOUND        ",
    " OSPC_ERR_TRAN_STATS_NEW_FAIL         ",
    " OSPC_ERR_TRAN_INVALID_CALC           ",
    " OSPC_ERR_TRAN_GET_DEST_NOT_ALLOWED   ",
    " OSPC_ERR_TRAN_AUTH_REQ_NOT_FOUND     ",
    " OSPC_ERR_TRAN_TXID_INVALID           ",
    " OSPC_ERR_TRAN_DATA_NOT_FOUND         ",
    " OSPC_ERR_TRAN_NO_NEW_AUTHREQ         ",
    " OSPC_ERR_TRAN_TOKEN_REUSE            ",
    " OSPC_ERR_TRAN_CLIENT_ERROR           ",
    " OSPC_ERR_TRAN_BAD_REQUEST            ",
    " OSPC_ERR_TRAN_UNAUTHORIZED           ",
    " OSPC_ERR_TRAN_CHAR_ENC_NOT_SUPD      ",
    " OSPC_ERR_TRAN_PARS_UNSUCCESSFUL      ",
    " OSPC_ERR_TRAN_UNSUPD_CRIT_ELEM       ",
    " OSPC_ERR_TRAN_SECURITY_PROBLEM       ",
    " OSPC_ERR_TRAN_SIG_INVALID            ",
    " OSPC_ERR_TRAN_CRYPTO_ALG_NOT_SUPD    ",
    " OSPC_ERR_TRAN_CERT_INVALID           ",
    " OSPC_ERR_TRAN_CERT_REVOKED           ",
    " OSPC_ERR_TRAN_ENCRYPTION_REQD        ",
    " OSPC_ERR_TRAN_SERVER_ERROR           ",
    " OSPC_ERR_TRAN_INTERNAL_SRVR_ERR      ",
    " OSPC_ERR_TRAN_UNIMPLEMENTED          ",
    " OSPC_ERR_TRAN_SERVICE_NOT_AVAIL      ",
    " OSPC_ERR_TRAN_TRANSIENT_SRVR_PROB    ",
    " OSPC_ERR_TRAN_LONG_TERM_SRVR_PROB    ",
    " OSPC_ERR_TRAN_TIME_PROB              ",
    " OSPC_ERR_TRAN_VALID_TIME_TOO_SOON    ",
    " OSPC_ERR_TRAN_TIME_INTERVAL_TOO_SMALL      ",
    " OSPC_ERR_TRAN_GENERIC_FAILURE        ",
    " OSPC_ERR_SEC_MODULE ",
    " OSPC_ERR_SEC_NOT_ENOUGH_SPACE_FOR_COPY     ",
    " OSPC_ERR_SEC_INVALID_ARG             ",
    " OSPC_ERR_SEC_PRIVATE_KEY_NOT_FOUND   ",
    " OSPC_ERR_SEC_NOT_IMPLEMENTED         ",
    " OSPC_ERR_SEC_NO_MEMORY               ",
    " OSPC_ERR_SEC_INVALID_SIG             ",
    " OSPC_ERR_SEC_SSL_INIT_DB_FAILED      ",
    " OSPC_ERR_SEC_NO_SPACE_FOR_CERTIFICATE      ",
    " OSPC_ERR_SEC_LOCAL_CERTINFO_UNDEFINED      ",
    " OSPC_ERR_SEC_ZERO_LENGTH_CERTIFICATE ",
    " OSPC_ERR_SEC_CERTIFICATE_TOO_BIG     ",
    " OSPC_ERR_SEC_INVALID_CERTIFICATE     ",
    " OSPC_ERR_SEC_NULL_CERTIFICATE        ",
    " OSPC_ERR_SEC_TOO_MANY_CERTIFICATES   ",
    " OSPC_ERR_SEC_NO_STORAGE_PROVIDED     ",
    " OSPC_ERR_SEC_NO_PRIVATE_KEY          ",
    " OSPC_ERR_SEC_INVALID_CONTEXT         ",
    " OSPC_ERR_SEC_UNABLE_TO_ALLOCATE_SPACE      ",
    " OSPC_ERR_SEC_CA_CERTIFICATES_DONT_MATCH    ",
    " OSPC_ERR_SEC_NO_AUTHORITY_CERTIFICATES     ",
    " OSPC_ERR_SEC_CACERT_INDEX_OVERFLOW     ",
    " OSPC_ERR_MSG_MODULE ",
    " OSPC_ERR_MIME_BUFFER_TOO_SMALL       ",
    " OSPC_ERR_MIME_MALLOC_FAILED          ",
    " OSPC_ERR_MIME_VAR_NOT_FOUND          ",
    " OSPC_ERR_MIME_NO_INPUT               ",
    " OSPC_ERR_MIME_INVALID_ARG            ",
    " OSPC_ERR_MIME_NO_MORE_SPACE          ",
    " OSPC_ERR_MIME_INVALID_TYPE           ",
    " OSPC_ERR_MIME_INVALID_SUBTYPE        ",
    " OSPC_ERR_MIME_PROTOCOL_NOT_FOUND     ",
    " OSPC_ERR_MIME_MICALG_NOT_FOUND       ",
    " OSPC_ERR_MIME_BOUNDARY_NOT_FOUND     ",
    " OSPC_ERR_MIME_CONTENT_TYPE_NOT_FOUND ",
    " OSPC_ERR_MIME_MSG_PARTS_NOT_FOUND    ",
    " OSPC_ERR_XML_INCOMPLETE              ",
    " OSPC_ERR_XML_BAD_ENC                 ",
    " OSPC_ERR_XML_BAD_ENTITY              ",
    " OSPC_ERR_XML_BAD_NAME                ",
    " OSPC_ERR_XML_BAD_TAG                 ",
    " OSPC_ERR_XML_BAD_ATTR                ",
    " OSPC_ERR_XML_BADCID_ENC              ",
    " OSPC_ERR_XML_BAD_ELEMENT             ",
    " OSPC_ERR_XML_NO_ELEMENT              ",
    " OSPC_ERR_XML_NO_ATTR                 ",
    " OSPC_ERR_XML_INVALID_ARGS            ",
    " OSPC_ERR_XML_BUFR_NEW_FAILED         ",
    " OSPC_ERR_XML_BFR_SZ_FAIL             ",
    " OSPC_ERR_XML_BFR_READ_BLOCK_FAIL     ",
    " OSPC_ERR_XML_MALLOC_FAILED           ",
    " OSPC_ERR_XML_INVALID_TYPE            ",
    " OSPC_ERR_XML_PARENT_NOT_FOUND        ",
    " OSPC_ERR_XML_CHILD_NOT_FOUND         ",
    " OSPC_ERR_XML_DATA_TYPE_NOT_FOUND     ",
    " OSPC_ERR_XML_BFR_WRITE_BLOCK_FAILED  ",
    " OSPC_ERR_DATA_NOCALLID               ",
    " OSPC_ERR_DATA_NO_TOKEN               ",
    " OSPC_ERR_DATA_BAD_NUMBER             ",
    " OSPC_ERR_DATA_NO_DEST                ",
    " OSPC_ERR_DATA_NO_USAGEIND            ",
    " OSPC_ERR_DATA_NO_STATUS              ",
    " OSPC_ERR_DATA_NO_USAGECNF            ",
    " OSPC_ERR_DATA_NO_AUTHIND             ",
    " OSPC_ERR_DATA_NO_AUTHREQ             ",
    " OSPC_ERR_DATA_NO_AUTHRSP             ",
    " OSPC_ERR_DATA_NO_AUTHCNF             ",
    " OSPC_ERR_DATA_NO_REAUTHREQ           ",
    " OSPC_ERR_DATA_NO_REAUTHRSP           ",
    " OSPC_ERR_DATA_INVALID_TYPE           ",
    " OSPC_ERR_DATA_NO_USAGE               ",
    " OSPC_ERR_DATA_NO_TOKENINFO           ",
    " OSPC_ERR_DATA_INVALID                ",
    " OSPC_ERR_DATA_NO_ALTINFO             ",
    " OSPC_ERR_DATA_NO_STATS               ",
    " OSPC_ERR_DATA_NO_DELAY               ",
    " OSPC_ERR_CERT_MALLOC_FAILED          ",
    " OSPC_ERR_COMM_MODULE",
    " OSPC_ERR_COMM_INVALID_SIZE           ",
    " OSPC_ERR_COMM_BAD_VALUE              ",
    " OSPC_ERR_COMM_PARSER                 ",
    " OSPC_ERR_COMM_NO_MEMORY              ",
    " OSPC_ERR_COMM_INUSE                  ",
    " OSPC_ERR_COMM_INVALID_ARG            ",
    " OSPC_ERR_COMM_NO_SVC_PTS             ",
    " OSPC_ERR_COMM_NO_SVC_PTS_AVAIL       ",
    " OSPC_ERR_COMM_THREAD_INIT_FAILED     ",
    " OSPC_ERR_MSGQ_NO_MEMORY              ",
    " OSPC_ERR_HTTP_BAD_HEADER_100         ",
    " OSPC_ERR_HTTP_BAD_HEADER_200         ",
    " OSPC_ERR_HTTP_BAD_QUEUE              ",
    " OSPC_ERR_HTTP_BAD_MESSAGE            ",
    " OSPC_ERR_HTTP_INVALID_ARG            ",
    " OSPC_ERR_HTTP_MALLOC_FAILED          ",
    " OSPC_ERR_HTTP_NEWCONN_FAILED         ",
    " OSPC_ERR_HTTP_SERVER_ERROR           ",
    " OSPC_ERR_HTTP_SHUTDOWN               ",
    " OSPC_ERR_HTTP_SSL_NEW_FAILED         ",
    " OSPC_ERR_HTTP_SSL_CTX_NEW_FAILED     ",
    " OSPC_ERR_HTTP_SERVICE_UNAVAILABLE    ",
    " OSPC_ERR_SOCK_SELECT_FAILED          ",
    " OSPC_ERR_SOCK_RECV_FAILED            ",
    " OSPC_ERR_SOCK_SEND_FAILED            ",
    " OSPC_ERR_SOCK_RECVBUF_MALLOC_FAILED  ",
    " OSPC_ERR_SOCK_RESET                  ",
    " OSPC_ERR_SOCK_CREATE_FAILED          ",
    " OSPC_ERR_SOCK_CLOSE_FAILED           ",
    " OSPC_ERR_SOCK_CONNECT_FAILED         ",
    " OSPC_ERR_SOCK_BLOCKIO_FAILED         ",
    " OSPC_ERR_SOCK_DISABLE_NAGLE_FAILED   ",
    " OSPC_ERR_SOCK_CONN_IN_PROGRESS       ",
    " OSPC_ERR_SSL_MALLOC_FAILED           ",
    " OSPC_ERR_SSL_INIT_CTX_FAILED         ",
    " OSPC_ERR_SSL_VERSION_FAILED          ",
    " OSPC_ERR_SSL_INIT_SESSION_FAILED     ",
    " OSPC_ERR_SSL_ATTACH_SOCK_FAILED      ",
    " OSPC_ERR_SSL_HANDSHAKE_FAILED        ",
    " OSPC_ERR_SSL_CLOSE_FAILED            ",
    " OSPC_ERR_SSL_READ_FAILED             ",
    " OSPC_ERR_SSL_WRITE_FAILED            ",
    " OSPC_ERR_SSL_GETCERT_FAILED          ",
    " OSPC_ERR_SSL_NO_ROOT_CA              ",
    " OSPC_ERR_SSL_SET_PRIVKEY_FAILED      ",
    " OSPC_ERR_SSL_PARSE_PRIVKEY_FAILED    ",
    " OSPC_ERR_SSL_ADD_CERTS_FAILED        ",
    " OSPC_ERR_SSL_ADD_DN_FAILED           ",
    " OSPC_ERR_UTIL_MODULE ",
    " OSPC_ERR_UTIL_NOT_ENOUGH_SPACE_FOR_COPY    ",
    " OSPC_ERR_UTIL_NO_TIME_STAMP_CREATED  ",
    " OSPC_ERR_UTIL_VALUE_NOT_FOUND        ",
    " OSPC_ERR_UTIL_MALLOC_FAILED          ",
    " OSPC_ERR_UTIL_INVALID_ARG            ",
    " OSPC_ERR_BUF_EMPTY                   ",
    " OSPC_ERR_BUF_INCOMPLETE              ",
    " OSPC_ERR_FAILRSN_MODULE",
    " OSPC_ERR_FAILRSN_NO_DATA             ",
    " OSPC_ERR_FAILRSN_INVALID             ",
    " OSPC_ERR_POW      ",
    " OSPC_ERR_OS_CONDVAR_TIMEOUT",
    " OSPC_ERR_X509_MODULE",
    " OSPC_ERR_X509_SERIAL_NUMBER_UNDEFINED      ",
    " OSPC_ERR_X509_CERTIFICATE_UNDEFINED  ",
    " OSPC_ERR_X509_INVALID_CONTEXT        ",
    " OSPC_ERR_X509_DECODING_ERROR         ",
    " OSPC_ERR_X509_UNABLE_TO_ALLOCATE_SPACE     ",
    " OSPC_ERR_X509_INVALID_DATE           ",
    " OSPC_ERR_X509_CERTIFICATE_EXPIRED    ",
    " OSPC_ERR_X509_CA_NOT_FOUND           ",
    " OSPC_ERR_PKCS1_MODULE",
    " OSPC_ERR_PKCS1_INVALID_PRIVATE_KEY_POINTER ",
    " OSPC_ERR_PKCS1_UNABLE_TO_ALLOCATE_SPACE    ",
    " OSPC_ERR_PKCS1_INVALID_CONTEXT       ",
    " OSPC_ERR_PKCS1_NULL_POINTER          ",
    " OSPC_ERR_PKCS1_PRIVATE_KEY_OVERFLOW  ",
    " OSPC_ERR_PKCS7_MODULE ",
    " OSPC_ERR_PKCS7_SIGNER_MISSING        ",
    " OSPC_ERR_PKCS7_INVALID_SIGNATURE     ",
    " OSPC_ERR_PKCS7_UNABLE_TO_ALLOCATE_SPACE ",
    " OSPC_ERR_PKCS7_ENCODING_ERROR        ",
    " OSPC_ERR_PKCS7_INVALID_POINTER       ",
    " OSPC_ERR_PKCS7_BUFFER_OVERFLOW       ",
    " OSPC_ERR_ASN1_MODULE  ",
    " OSPC_ERR_ASN1_NULL_POINTER           ",
    " OSPC_ERR_ASN1_INVALID_ELEMENT_TAG    ",
    " OSPC_ERR_ASN1_UNEXPECTED_HIGH_TAG    ",
    " OSPC_ERR_ASN1_INVALID_PRIMITIVE_TAG  ",
    " OSPC_ERR_ASN1_UNABLE_TO_ALLOCATE_SPACE  ",
    " OSPC_ERR_ASN1_INVALID_CONTEXT ",
    " OSPC_ERR_ASN1_INVALID_TIME           ",
    " OSPC_ERR_ASN1_PARSE_ERROR            ",
    " OSPC_ERR_ASN1_PARSE_COMPLETE         ",
    " OSPC_ERR_ASN1_PARSE_DEFAULTED        ",
    " OSPC_ERR_ASN1_LENGTH_OVERFLOW        ",
    " OSPC_ERR_ASN1_UNSUPPORTED_TAG        ",
    " OSPC_ERR_ASN1_OBJECTID_NOT_FOUND     ",
    " OSPC_ERR_ASN1_OBJECTID_MISMATCH      ",
    " OSPC_ERR_ASN1_UNEXPECTED_INT_BASE    ",
    " OSPC_ERR_ASN1_BUFFER_OVERFLOW        ",
    " OSPC_ERR_ASN1_INVALID_DATAREFID      ",
    " OSPC_ERR_ASN1_NO_CONTENT_VALUE_FOR_ELEMENT ",
    " OSPC_ERR_ASN1_INTEGER_OVERFLOW  ",
    " OSPC_ERR_CRYPTO_MODULE  ",
    " OSPC_ERR_CRYPTO_INVALID_PARAMETERS     ",
    " OSPC_ERR_CRYPTO_UNABLE_TO_ALLOCATE_SPACE ",
    " OSPC_ERR_CRYPTO_SIGNATURE_DID_NOT_VERIFY ",
    " OSPC_ERR_CRYPTO_IMPLEMENTATION_SPECIFIC_ERROR",
    " OSPC_ERR_CRYPTO_INVALID_POINTER  ",
    " OSPC_ERR_CRYPTO_NOT_ENOUGH_SPACE ",
    " OSPC_ERR_PKCS8_MODULE  ",
    " OSPC_ERR_PKCS8_INVALID_PRIVATE_KEY_POINTER ",
    " OSPC_ERR_PKCS8_UNABLE_TO_ALLOCATE_SPACE    " ,
    " OSPC_ERR_PKCS8_INVALID_CONTEXT       ",
    " OSPC_ERR_PKCS8_NULL_POINTER          ",
    " OSPC_ERR_PKCS8_PRIVATE_KEY_OVERFLOW  ",
    " OSPC_ERR_B64_MODULE                  ",
    " OSPC_ERR_B64_ENCODE_FAILED           ",
    " OSPC_ERR_B64_DECODE_FAILED           ",
    " OSPC_ERR_AUDIT_MODULE    ",
    " OSPC_ERR_AUDIT_MALLOC_FAILED         ",
    " OSPC_ERR_AUDIT_NOT_FOUND             ",
    " OSPC_ERR_AUDIT_THREAD_INIT_FAILED    ",
    " OSPC_ERR_AUDIT_DUMP_FAILED           ",
    " OSPC_ERR_TRANSID_MODULE    ",
    " OSPC_ERR_TRANSID                     "
} ;

OSPErrStrings* OSPErrStrings::_ospErrStrIns = 0;

OSPErrStrings& OSPErrStrings::Instance( void )
{
    if (_ospErrStrIns == 0 )
    {
        _ospErrStrIns = new OSPErrStrings;
    }
    return *_ospErrStrIns;

}

OSPErrStrings::OSPErrStrings()
{
    // ospErr[] is an array of int, need to divide by 4
    // to find out the number of OSP errors
    int maxOspErr = static_cast < int > (sizeof(ospErr)) / 4;

    cpLog(LOG_DEBUG, "OSPErrStrings ctor invoked, max opsErr = %d",
          maxOspErr);
    // build error map
    for (int i = 0; i < maxOspErr; i++)
    {
        _ospErrMap[ospErr[i]] = OSPErrString[i];
    }
}

OSPErrStrings::~OSPErrStrings()
{
    cpLog(LOG_DEBUG, "OSPErrStrings dtor invoked");
    if (_ospErrStrIns)
    {
        delete _ospErrStrIns;
        _ospErrStrIns = 0;
    }
}

const char * OSPErrStrings::dumpErr( int err )
{
    if (err > OSPC_ERR_TRANSID)
        return ("unknown OSP error string");
    else
        return ((_ospErrMap[err]).c_str());
}



