// Copyright (c) 2002 Cathay Networks, Inc. All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
// 
// 3. The names "VOCAL", "Vovida Open Communication Application Library", and
// "Vovida Open Communication Application Library (VOCAL)" must not be used to
// endorse or promote products derived from this software without prior written
// permission. For written permission, please contact vocal@vovida.org.
// 
// 4. Products derived from this software may not be called "VOCAL", nor may
// "VOCAL" appear in their name, without prior written permission.
// 
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT ARE DISCLAIMED.
// IN NO EVENT SHALL CATHAY NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR
// ANY DAMAGES IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//

#include "Data.hxx"
#include "StringUtil.hxx"
#include <strstream>

using namespace Epoisses;
using namespace std;


bool 
StringUtil::isPrefix(const string& pref, const string& str)
{
   if (pref.size() > str.size())
   {
      return false;
   }
   for(string::const_iterator i = pref.begin(),
          j = str.begin();
          i != pref.end(); i++, j++)
   {
      if (*i != *j)
      {
         return false;
      }
   }
   return true;
}

bool 
StringUtil::isPrefix(const Data& pref, const Data& str)
{
   if (pref.length() > str.length())
   {
      return false;
   }
   for(int i=0; i<pref.length(); i++)
   {
      if (const_cast<Data&>(pref)[i] != const_cast<Data&>(str)[i])
      {
         return false;
      }
   }
   return true;
}

string 
StringUtil::toLower(const string& mixed)
{
   string lowered(mixed);
   transform(lowered.begin(),lowered.end(),lowered.begin(), ::tolower);
   return lowered;
}

string 
StringUtil::stripQuotes(const string& maybeQuoted)
{
   if (maybeQuoted.empty())
   {
      return maybeQuoted;
   }
   if (maybeQuoted[0] == '\'')
   {
      return maybeQuoted.substr(1, maybeQuoted.size() - 2);
   }
   return maybeQuoted;
}
