package org.vovida.prov.psLib;

public class BooleanArrayField extends Field
{ 
    public BooleanArrayField(String name) 
    { 
	super(name); 
    } 

    public Filter like(BooleanArrayField stringField) 
    { 
	return new Like(this, stringField); 
    } 

    public Filter eq(BooleanArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 
             
    public Filter eq(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter ne(BooleanArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 

    public Filter ne(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter lt(BooleanArrayField stringField) 
    { 
	return new Lt(this, stringField); 
    } 

    public Filter lt(String v) 
    { 
	return new Lt(this, new Constant(v)); 
    } 

    public Filter gt(BooleanArrayField stringField) 
    { 
	return new Gt(this, stringField); 
    } 

    public Filter gt(String v) 
    { 
	return new Gt(this, new Constant(v));
    } 

    public Filter le(BooleanArrayField stringField) 
    { 
	return new Le(this, stringField); 
    } 

    public Filter le(String v) 
    { 
	return new Le(this, new Constant(v));
    } 

    public Filter ge(BooleanArrayField stringField) 
    { 
	return new Ge(this, stringField); 
    } 

    public Filter ge(String v) 
    { 
	return new Ge(this, new Constant(v));
    } 

    public BooleanArrayAssignment assign(BooleanArrayField v) 
    { 
	return new BooleanArrayAssignment(this, v); 
    } 

    public BooleanArrayAssignment assign(boolean[] v) 
    { 
	return new BooleanArrayAssignment(this, new Constant(v)); 
    } 

    public BooleanArrayAssignment assign(java.util.List v) 
    { 
	return new BooleanArrayAssignment(this, new Constant(v)); 
    } 

    public boolean[] bound() 
    { 
	if (!isBound()) {
	    throw new NotBoundException(); 
	} 
               
	return value; 
    } 
               
    void bind(String v) 
    { 
	java.util.List l = new java.util.ArrayList();
	// tokenize by comma
	java.util.StringTokenizer tok = 
	    new java.util.StringTokenizer(v, ",", false);
	while (tok.hasMoreTokens()) {
	    l.add(tok.nextToken());
	}

	value = new boolean[l.size()];
	java.util.Iterator it = l.iterator();
	int i = 0;
	while (it.hasNext()) {
	    value[i++] = Boolean.valueOf((String)it.next()).booleanValue();
	}
    } 

    private boolean[] value; 
} 
