package org.vovida.prov.psLib;

public class BooleanField extends Field implements Filter
{ 
      public BooleanField(String name) 
      { 
         super(name); 
      } 

      public Filter eq(BooleanField booleanField) 
      { 
         return new Eq(this, booleanField); 
      } 
             
      public Filter eq(boolean v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter ne(BooleanField booleanField) 
      { 
         return new Eq(this, booleanField); 
      } 

      public Filter ne(boolean v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter not() 
      { 
         return new Not(this); 
      } 
             
      public Filter and(BooleanField booleanField) 
      { 
         return new And(this, booleanField); 
      } 

      public Filter and(boolean v) 
      { 
         return new And(this, new Identity(v));
      } 

      public Filter or(BooleanField booleanField) 
      { 
         return new Or(this, booleanField); 
      } 

      public Filter or(boolean v) 
      { 
         return new Or(this, new Identity(v));
      } 

      public BooleanAssignment assign(BooleanField v) 
      { 
         return new BooleanAssignment(this, v); 
      } 

      public BooleanAssignment assign(boolean v) 
      { 
         return new BooleanAssignment(this, new Constant(v)); 
      } 

      public boolean bound() 
      { 
         if (!isBound()) {
	    throw new NotBoundException(); 
         } 
               
         return value; 
      } 
               
      void bind(String v) 
      { 
         if (v.equals("t"))
         {
            value = true;
         }
         else
         {
            value = false;
         }
      } 

      private boolean value; 
} 
