package org.vovida.prov.psLib;

public class DoubleArrayField extends Field
{ 
    public DoubleArrayField(String name) 
    { 
	super(name); 
    } 

    public Filter like(DoubleArrayField stringField) 
    { 
	return new Like(this, stringField); 
    } 

    public Filter eq(DoubleArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 
             
    public Filter eq(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter ne(DoubleArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 

    public Filter ne(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter lt(DoubleArrayField stringField) 
    { 
	return new Lt(this, stringField); 
    } 

    public Filter lt(String v) 
    { 
	return new Lt(this, new Constant(v)); 
    } 

    public Filter gt(DoubleArrayField stringField) 
    { 
	return new Gt(this, stringField); 
    } 

    public Filter gt(String v) 
    { 
	return new Gt(this, new Constant(v));
    } 

    public Filter le(DoubleArrayField stringField) 
    { 
	return new Le(this, stringField); 
    } 

    public Filter le(String v) 
    { 
	return new Le(this, new Constant(v));
    } 

    public Filter ge(DoubleArrayField stringField) 
    { 
	return new Ge(this, stringField); 
    } 

    public Filter ge(String v) 
    { 
	return new Ge(this, new Constant(v));
    } 

    public DoubleArrayAssignment assign(DoubleArrayField v) 
    { 
	return new DoubleArrayAssignment(this, v); 
    } 

    public DoubleArrayAssignment assign(double[] v) 
    { 
	return new DoubleArrayAssignment(this, new Constant(v)); 
    } 

    public DoubleArrayAssignment assign(java.util.List v) 
    { 
	return new DoubleArrayAssignment(this, new Constant(v)); 
    } 

    public double[] bound() 
    { 
	if (!isBound()) {
	    throw new NotBoundException(); 
	} 
               
	return value; 
    } 
               
    void bind(String v) 
    { 
	java.util.List l = new java.util.ArrayList();
	// tokenize by comma
	java.util.StringTokenizer tok = 
	    new java.util.StringTokenizer(v, ",", false);
	while (tok.hasMoreTokens()) {
	    l.add(tok.nextToken());
	}

	value = new double[l.size()];
	java.util.Iterator it = l.iterator();
	int i = 0;
	while (it.hasNext()) {
	    value[i++] = Double.parseDouble((String)it.next());
	}
    } 

    private double[] value; 
} 
