package org.vovida.prov.psLib;

public class DoubleField extends Field
{ 
      public DoubleField(String name) 
      { 
         super(name); 
      } 

      public Filter eq(DoubleField doubleField) 
      { 
         return new Eq(this, doubleField); 
      } 
             
      public Filter eq(double v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter ne(DoubleField doubleField) 
      { 
         return new Eq(this, doubleField); 
      } 

      public Filter ne(double v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter lt(DoubleField doubleField) 
      { 
         return new Lt(this, doubleField); 
      } 

      public Filter lt(double v) 
      { 
         return new Lt(this, new Constant(v)); 
      } 

      public Filter gt(DoubleField doubleField) 
      { 
         return new Gt(this, doubleField); 
      } 

      public Filter gt(double v) 
      { 
         return new Gt(this, new Constant(v));
      } 

      public Filter le(DoubleField doubleField) 
      { 
         return new Le(this, doubleField); 
      } 

      public Filter le(double v) 
      { 
         return new Le(this, new Constant(v));
      } 

      public Filter ge(DoubleField doubleField) 
      { 
         return new Ge(this, doubleField); 
      } 

      public Filter ge(double v) 
      { 
         return new Ge(this, new Constant(v));
      } 

      public DoubleAssignment assign(DoubleField v) 
      { 
         return new DoubleAssignment(this, v); 
      } 

      public DoubleAssignment assign(double v) 
      { 
         return new DoubleAssignment(this, new Constant(v)); 
      } 

      public double bound() 
      { 
         if (!isBound()) {
	    throw new NotBoundException(); 
         } 
               
         return value; 
      } 
               
      void bind(String v) 
      { 
         if (v == "") 
         {
            value = 0.0;
         }
         else
         {
            value = Double.parseDouble(v); 
         }
      } 

      private double value; 
} 
