package org.vovida.prov.psLib;

public class IntArrayField extends Field
{ 
    public IntArrayField(String name) 
    { 
	super(name); 
    } 

    public Filter like(IntArrayField stringField) 
    { 
	return new Like(this, stringField); 
    } 

    public Filter eq(IntArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 
             
    public Filter eq(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter ne(IntArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 

    public Filter ne(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter lt(IntArrayField stringField) 
    { 
	return new Lt(this, stringField); 
    } 

    public Filter lt(String v) 
    { 
	return new Lt(this, new Constant(v)); 
    } 

    public Filter gt(IntArrayField stringField) 
    { 
	return new Gt(this, stringField); 
    } 

    public Filter gt(String v) 
    { 
	return new Gt(this, new Constant(v));
    } 

    public Filter le(IntArrayField stringField) 
    { 
	return new Le(this, stringField); 
    } 

    public Filter le(String v) 
    { 
	return new Le(this, new Constant(v));
    } 

    public Filter ge(IntArrayField stringField) 
    { 
	return new Ge(this, stringField); 
    } 

    public Filter ge(String v) 
    { 
	return new Ge(this, new Constant(v));
    } 

    public IntArrayAssignment assign(IntArrayField v) 
    { 
	return new IntArrayAssignment(this, v); 
    } 

    public IntArrayAssignment assign(int[] v) 
    { 
	return new IntArrayAssignment(this, new Constant(v)); 
    } 

    public IntArrayAssignment assign(java.util.List v) 
    { 
	return new IntArrayAssignment(this, new Constant(v)); 
    } 

    public int[] bound() 
    { 
	if (!isBound()) {
	    throw new NotBoundException(); 
	} 
               
	return value; 
    } 
               
    void bind(String v) 
    { 
	java.util.List l = new java.util.ArrayList();
	// tokenize by comma
	java.util.StringTokenizer tok = 
	    new java.util.StringTokenizer(v, ",", false);
	while (tok.hasMoreTokens()) {
	    l.add(tok.nextToken());
	}

	value = new int[l.size()];
	java.util.Iterator it = l.iterator();
	int i = 0;
	while (it.hasNext()) {
	    value[i++] = Integer.parseInt((String)(it.next()));
	}
    } 

    private int[] value; 
} 
