package org.vovida.prov.psLib;

public class IntField extends Field
{ 
      public IntField(String name) 
      { 
         super(name); 
      } 

      public Filter eq(IntField intField) 
      { 
         return new Eq(this, intField); 
      } 
             
      public Filter eq(int v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter ne(IntField intField) 
      { 
         return new Eq(this, intField); 
      } 

      public Filter ne(int v) 
      { 
         return new Eq(this, new Constant(v)); 
      } 

      public Filter lt(IntField intField) 
      { 
         return new Lt(this, intField); 
      } 

      public Filter lt(int v) 
      { 
         return new Lt(this, new Constant(v)); 
      } 

      public Filter gt(IntField intField) 
      { 
         return new Gt(this, intField); 
      } 

      public Filter gt(int v) 
      { 
         return new Gt(this, new Constant(v));
      } 

      public Filter le(IntField intField) 
      { 
         return new Le(this, intField); 
      } 

      public Filter le(int v) 
      { 
         return new Le(this, new Constant(v));
      } 

      public Filter ge(IntField intField) 
      { 
         return new Ge(this, intField); 
      } 

      public Filter ge(int v) 
      { 
         return new Ge(this, new Constant(v));
      } 

      public IntAssignment assign(IntField v) 
      { 
         return new IntAssignment(this, v); 
      } 

      public IntAssignment assign(int v) 
      { 
         return new IntAssignment(this, new Constant(v)); 
      } 

      public int bound() 
      { 
         if (!isBound()) {
	    throw new NotBoundException(); 
         } 
               
         return value; 
      } 
               
      void bind(String v) 
      { 
         if (v == "")
         {
            value = 0;
         }
         else 
         {
            value = Integer.parseInt(v); 
         }
      } 

      private int value; 
} 
