package org.vovida.prov.psLib;

public class StringField extends Field
{ 
    public StringField(String name) 
    { 
	super(name); 
    } 

    public Filter like(StringField stringField) 
    { 
	return new Like(this, stringField); 
    } 

    public Filter like(String v) 
    { 
	return new Like(this, new Constant(v)); 
    } 

    public Filter eq(StringField stringField) 
    { 
	return new Eq(this, stringField); 
    } 
             
    public Filter eq(String v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter ne(StringField stringField) 
    { 
	return new Ne(this, stringField); 
    } 

    public Filter ne(String v) 
    { 
	return new Ne(this, new Constant(v)); 
    } 

    public Filter lt(StringField stringField) 
    { 
	return new Lt(this, stringField); 
    } 

    public Filter lt(String v) 
    { 
	return new Lt(this, new Constant(v)); 
    } 

    public Filter gt(StringField stringField) 
    { 
	return new Gt(this, stringField); 
    } 

    public Filter gt(String v) 
    { 
	return new Gt(this, new Constant(v));
    } 

    public Filter le(StringField stringField) 
    { 
	return new Le(this, stringField); 
    } 

    public Filter le(String v) 
    { 
	return new Le(this, new Constant(v));
    } 

    public Filter ge(StringField stringField) 
    { 
	return new Ge(this, stringField); 
    } 

    public Filter ge(String v) 
    { 
	return new Ge(this, new Constant(v));
    } 

    public StringAssignment assign(StringField v) 
    { 
	return new StringAssignment(this, v); 
    } 

    public StringAssignment assign(String v) 
    { 
	return new StringAssignment(this, new Constant(v)); 
    } 

    public String bound() 
    { 
	if (!isBound()) {
	    throw new NotBoundException(); 
	} 
               
	return value; 
    } 
               
    void bind(String v) 
    { 
	value = BaseField.decodeString(v); 
    } 

    private String value; 
} 
