package org.vovida.prov.psLib.test;

import org.vovida.prov.psLib.*;

/**
 * This is an example. Delete it if the name is in the way. */
public class User
{
      public User(User.Db db)
      {
         this.userId = db.userId.bound();
         this.firstName = db.firstName.bound();
         this.lastName = db.lastName.bound();
         this.expired = db.expired.bound();
         this.count = db.count.bound();
         this.credits = db.credits.bound();
         this.speed = db.speed.bound();
         this.aliases = db.aliases.bound();
      }

      public String toString()
      {
         StringBuffer s = new StringBuffer();

         s.append("User[firstName=");
         s.append(firstName);
         s.append(" lastname=");
         s.append(lastName);
         s.append(" expired=");
         s.append(expired);
         s.append(" count=");
         s.append(count);
         s.append(" credits=");
         s.append(credits);
         s.append(" speed=");
         s.append(speed);
         s.append(" aliases={");
         
         for (int i = 0; i < aliases.length; i++)
         {
            if (i != 0)
            {
               s.append(",");
            }
            s.append(aliases[i]);
         }
         s.append("}");
         s.append("]");

         return s.toString();
      }

      public static class Db extends Domain
      {
            public Db()
            {
               super("testusers");
            }

            public FieldList getAll()
            {
               return all;
            }

            public final StringField userId = new StringField("userid");
            public final StringField firstName = new StringField("firstName");
            public final StringField lastName = new StringField("lastName");
            public final BooleanField expired = new BooleanField("expired");
            public final IntField count = new IntField("count");
            public final IntField credits = new IntField("credits");
            public final DoubleField speed = new DoubleField("speed");
            public final StringArrayField aliases = new StringArrayField("aliases");
	
            private final FieldList all = new FieldList(userId,
                                                        firstName,
                                                        lastName,
                                                        expired,
                                                        count,
                                                        credits,
                                                        speed,
                                                        aliases);
      }
      public final String userId;
      public final String firstName;
      public final String lastName;
      public final boolean expired;
      public final int count;
      public final int credits;
      public final double speed;
      public final String[] aliases;
}
