
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const CPLStartStateHolder_cxx_Version =
    "$Id: CPLStartStateHolder.cxx,v 1.9 2002/03/19 21:39:41 jason Exp $";
#include "CPLStartStateHolder.hxx"

using namespace Vocal;

///Constructor
CPLStartStateHolder::CPLStartStateHolder()
{
#ifdef MEM_TEST
    cpLog( LOG_DEBUG, "new CPLStartStateHolder[%x]", this );
#endif
}  //CPLStartStateHolder


///Copy Constructor
CPLStartStateHolder::CPLStartStateHolder( const CPLStartStateHolder& rhs )
{
    myOutgoingStart = rhs.myOutgoingStart;
    myIncomingStart = rhs.myIncomingStart;
}  //Copy Constructor


///Destructor
CPLStartStateHolder::~CPLStartStateHolder()
{
#ifdef MEM_TEST
    cpLog( LOG_DEBUG, "~CPLStartStateHolder[%x]", this );
#endif
}  //~CPLStartStateHolder


///Retrieve Incoming Start State
Sptr < State >
CPLStartStateHolder::getIncoming() const
{
    return myIncomingStart;
}  //getIncomingStateMachine


///Retrieve Outgoing Start State
Sptr < State >
CPLStartStateHolder::getOutgoing() const
{
    return myOutgoingStart;
}  //getOutgoing


///Set Incoming Start State
void
CPLStartStateHolder::setIncoming( Sptr < State > state )
{
    myIncomingStart = state;
}  //setIncoming


///Set Outgoing Start State
void
CPLStartStateHolder::setOutgoing( Sptr < State > state )
{
    myOutgoingStart = state;
}  //setOutgoing


///Clear All
void
CPLStartStateHolder::clearAll( )
{
    myIncomingStart = 0;
    myOutgoingStart = 0;
}  //clearAll

//End of File

