/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
package com.vovida.telephony;

/**
 * VCMsgTypes provides definition for consts which are used
 * by the package com.vovida.telephony
 */

public interface VCMsgTypes 
{
    // Request Types
    public static final int CONNECT = 101;
    public static final int DISCONNECT = 102;
    public static final int ANSWER = 103;
    public static final int TRANSFER = 104;


    public static final int CALLCREATE = 150;
    public static final int REGISTER = 151;
    public static final int CHKREGISTER = 152;


    // Response Types
    public static final int CONNECTRESP = 201;
    public static final int DISCONNECTRESP = 202;
    public static final int ANSWERRESP = 203;
    public static final int TRANSFERRESP = 204;


    public static final int CALLCREATERESP = 250;
    public static final int REGISTERRESP = 251;
    public static final int CHKREGISTERRESP = 252;


    // Notification Types
    public static final int CALLCREATED = 301;
    public static final int CALLACTIVE = 302;
    public static final int CALLINVALID = 303;

    public static final int CONNCREATED = 311;
    public static final int CONNINPROGRESS = 312;
    public static final int CONNALERTING = 313;
    public static final int CONNCONNECTED = 314;
    public static final int CONNDISCONNECTED = 315;
    public static final int CONNFAILED = 316;
    public static final int CONNUNKNOWN = 317;

    public static final int TERMCONNCREATED = 321;
    public static final int TERMCONNRINGING = 322;
    public static final int TERMCONNACTIVE = 323;
    public static final int TERMCONNPASSIVE = 324;
    public static final int TERMCONNDROPPED = 325;
    public static final int TERMCONNUNKNOWN = 326;  
    public static final int TERMCONNHELD = 327;


    // Value Types
    public static final int SUCCESS = 1;
    public static final int FAILED = 2;
    public static final int INPROGRESS = 3;
    public static final int UNKNOWN = 4;
    public static final int TIMEOUT = 5;

    // addAddress Value Types - see CallControlConnection
    public static final int ADDRESSING_COMPLETE = 1;
    public static final int ADDRESSING_INCOMPLETE = 3;

    // Connection Types
    public static final int BOTH = 0;
    public static final int ORIG = 1;
    public static final int TERM = 2;

    // Msg buffer size in bytes
    public static final int PACKET_BUFFER_SIZE = 4096;
}
