#ifndef __EVTCAPMGR_H_
#define __EVTCAPMGR_H_

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const EvtCapMgr_hxx_Version = 
"$Id: EvtCapMgr.hxx,v 1.4 2001/05/23 20:50:47 vzubarev Exp $";

#include <assert.h>

#include "mte/EvtDirect.hxx"
#include "mte/EvtBind1.hxx"
#include "mte/EvtSM1.hxx"
#include "mte/EvtSM2.hxx"
#include "mte/EventStatic.hxx"
#include "mte/EvtFeature.hxx"
#include "mte/EvtException.hxx"
#include "mte/BEvent.hxx"

#include "SM_CapManager.hxx"
#include "FeatureTCSDefs.hxx"
#include "FeatureSDPDefs.hxx"


using namespace CapabilityTranslator;

namespace CapabilityManager
{

    typedef mte::BEvent BaseEvent;

    // All TCS Events
    
    typedef mte::EvtFeature<SM_CapManager,
    			    PatternTCS,
			    FeatureTCS,
			    FeatureTCSBase,
			    &SM_CapManager::getFeatureTCS> EvtFeatureTCS;

    typedef mte::EvtSM1<SM_CapManager, EvtFeatureTCS> EvtSM1TCS;
        
    // All SDP Events
    
    typedef mte::EvtFeature<SM_CapManager,
    			    PatternSDP,
			    FeatureSDP,
			    FeatureSDPBase,
			    &SM_CapManager::getFeatureSDP> EvtFeatureSDP;

    typedef mte::EvtSM1<SM_CapManager, EvtFeatureSDP> EvtSM1SDP;

    typedef mte::EvtSM2<SM_CapManager, EvtFeatureTCS, EvtFeatureSDP> EvtSM2CapMgr;

    // Capability Manager user events
    
    typedef mte::EvtDirect<EvtSM1TCS, BaseEvent> EvtDirectTCS;
    typedef mte::EvtBind1<mte::EventStatic<BaseEvent>, EvtDirectTCS> EvtUserTCS;
    
    typedef mte::EvtDirect<EvtSM1SDP, BaseEvent> EvtDirectSDP;
    typedef mte::EvtBind1<mte::EventStatic<BaseEvent>, EvtDirectSDP> EvtUserSDP;

    typedef mte::EvtDirect<EvtSM2CapMgr, BaseEvent> EvtDirectCapMgr;
    typedef mte::EvtBind1<mte::EventStatic<BaseEvent>, EvtDirectCapMgr> EvtUserCapMgr;
}

#endif
