#!/bin/sh
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#
# $Id: config.cgi,v 1.5 2000/08/12 00:15:29 icahoon Exp $
#
# $Log: config.cgi,v $
# Revision 1.5  2000/08/12 00:15:29  icahoon
# added license
#
# Revision 1.4  2000/07/25 02:58:30  icahoon
# minor fix
#
# Revision 1.3  2000/07/24 22:34:44  icahoon
# moved to vocal
#
# Revision 1.2  2000/07/05 22:58:45  hyu
# Merging BRANCH_CURD into HEAD.
#
# Revision 1.1.8.3  2000/06/29 21:30:53  icahoon
# minor changes
#
# Revision 1.1.8.2  2000/06/23 08:44:37  icahoon
# minor fixes
#
# Revision 1.1.8.1  2000/06/15 21:28:50  icahoon
# mostly registration updates, some router / translator additions
#
# Revision 1.1.2.2  2000/06/12 23:10:03  icahoon
# support for marshal command line options
#
# Revision 1.1.2.1  2000/06/06 18:05:43  icahoon
# support sipport, support SIGTEM, remove timeout
#
# Revision 1.1  2000/05/27 01:47:42  icahoon
# Prototype web interface to the sip to h323 call signalling gateway
#
#

# disable filename globbing
set -f

echo Content-type: text/html
echo

cat << EOF
<html>

<!-- #include virtual="/vocal/common/copyright"-->

<head>
    <title>Sip To H.323 Call Signalling Gateway Configuration</title>

    <link rel="stylesheet" href="/vocal/common/style.css" type="text/css">
</head>

<body>
<body>

<form   action="/vocal/siph323csgw/update_config.cgi"
	target="main"
	method="GET">

<table border="0" cellspacing="0" cellpadding="10" width="100%">
    <tr>
	<td colspan="4" valign="bottom" align="left" bgcolor="#D2C8B6">
	<h3>Sip To H.323 Call Signalling Gateway Configuration</h3>
	</td>
    </tr>

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
	    &nbsp;
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    GatekeeperIdentifier
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="gkId"
EOF

echo "               value=\"`cat config/gkid`\""

cat << EOF    
    	    >
    	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    EndpointIdentifier Prefix
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="eptId"
EOF

echo "                value=\"`cat config/eptid`\""

cat << EOF    
    	    >
    	</td>
    </tr>
    
    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Log Level
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <select name="logLevel">
EOF

LOG_LVL=`cat config/loglvl`

if [ "$LOG_LVL" = "" ]
then
    LOG_LVL="LOG_INFO"
fi

echo "		<option value=\"$LOG_LVL\">$LOG_LVL</option>"

echo "		<option value=\"$LOG_LVL\">--</option>"

cat << EOF
    	    	<option value="LOG_ERR">LOG_ERR</option>
    	    	<option value="LOG_WARNING">LOG_WARNING</option>
    	    	<option value="LOG_NOTICE">LOG_NOTICE</option>
    	    	<option value="LOG_INFO">LOG_INFO</option>
    	    	<option value="LOG_DEBUG">LOG_DEBUG</option>
    	    	<option value="LOG_TRACE">LOG_TRACE</option>
    	    	<option value="LOG_VERBOSE">LOG_VERBOSE</option>
    	    </select>
	</td>
    </tr>


    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    SIP Port
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="sipport"
EOF

echo "               value=\"`cat config/sipport`\""

cat << EOF
	    >
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Remote SIP Entity IP Address
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="sipRemote"
EOF

echo "               value=\"`cat config/sipremote`\""

cat << EOF
	    >
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Remote SIP Entity Type
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <select name="sipRemoteType">
EOF

SIP_REMOTE_TYPE=`cat config/sipremotetype`

if [ "$SIP_REMOTE_TYPE" = "" ]
then
    SIP_REMOTE_TYPE="SIP_Proxy"
fi

echo "		<option value=\"$SIP_REMOTE_TYPE\">$SIP_REMOTE_TYPE</option>"

echo "		<option value=\"$SIP_REMOTE_TYPE\">--</option>"

cat << EOF
    	    	<option value="SIP_Proxy">SIP Proxy</option>
    	    	<option value="SIP_User_Agent">SIP User Agent</option>
    	    </select>
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Media Control
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <select name="mediaControl">
EOF

MEDIA_CONTROL=`cat config/mediacontrol`

if [ "$MEDIA_CONTROL" = "" ]
then
    MEDIA_CONTROL="Between_endpoints"
fi

echo "		<option value=\"$MEDIA_CONTROL\">$MEDIA_CONTROL</option>"

echo "		<option value=\"$MEDIA_CONTROL\">--</option>"

cat << EOF
    	    	<option value="Between_endpoints">Between endpoints</option>
    	    	<option value="Via_gateway">Via gateway</option>
    	    </select>
	</td>
    </tr>

    <tr>
    	<td colspan="4" bgcolor="#FFFFFF" td align="left" valign="top">
    	    <input type="submit" name="op" value="Submit">
	</td>
    </tr>

</table>

</form>

</body>
</html>

EOF
