#!/bin/sh
#
# $Id: config.cgi,v 1.2 2000/08/12 00:15:47 icahoon Exp $
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#
# $Log: config.cgi,v $
# Revision 1.2  2000/08/12 00:15:47  icahoon
# added license
#
# Revision 1.1  2000/07/28 07:00:03  icahoon
# first version
#
#

# disable filename globbing
set -f

echo Content-type: text/html
echo

cat << EOF
<html>

<!-- #include virtual="/vocal/common/copyright"-->

<head>
    <title>User Agent Configuration</title>

    <link rel="stylesheet" href="/vocal/common/style.css" type="text/css">
</head>

<body>
<body>

<form   action="/vocal/ua/update_config.cgi"
	target="main"
	method="GET">

<table border="0" cellspacing="0" cellpadding="10" width="100%">

    <tr>
	<td colspan="4" valign="bottom" align="left" bgcolor="#D2C8B6">
	<h3>User Agent Configuration</h3>
	</td>
    </tr>

    <!-- == Phone Number ================================================ -->

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
	    &nbsp;
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Phone Number
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="phone"
EOF

echo "               value=\"`cat config/phone`\""

cat << EOF    
    	    >
    	</td>
    </tr>

    <!-- == Display Name ================================================ -->

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Display Name
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="display"
EOF

echo "               value=\"`cat config/display`\""

cat << EOF    
    	    >
    	</td>
    </tr>

    <!-- == Log Level ================================================ -->

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Log Level
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <select name="log_level">
EOF

LOG_LEVEL=`cat config/log_level`

if [ "$LOG_LEVEL" = "" ]
then
    LOG_LEVEL=LOG_INFO
fi

echo "		<option value=\"$LOG_LEVEL\">$LOG_LEVEL</option>"

echo "		<option value=\"$LOG_LEVEL\">--</option>"

cat << EOF
    	    	<option value="LOG_ERR">LOG_ERR</option>
    	    	<option value="LOG_WARNING">LOG_WARNING</option>
    	    	<option value="LOG_NOTICE">LOG_NOTICE</option>
    	    	<option value="LOG_INFO">LOG_INFO</option>
    	    	<option value="LOG_DEBUG">LOG_DEBUG</option>
    	    	<option value="LOG_DEBUG_STACK">LOG_DEBUG_STACK</option>
    	    </select>
	</td>
    </tr>

    <!-- == SIP Port ================================================ -->

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    SIP Port
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="port"
EOF

echo "               value=\"`cat config/port`\""

cat << EOF    
    	    >
    	</td>
    </tr>

    <!-- == SIP Client ================================================ -->

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Remote SIP Client IP Address:Port
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <input 	
		type="text" 
		size="20" 
		name="remote"
EOF

echo "               value=\"`cat config/remote`\""

cat << EOF
	    >
	</td>
    </tr>

    <!-- == SIP Client Type ============================================ -->

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Remote SIP Client Type
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
	    <select name="remote_type">
EOF

REMOTE_TYPE=`cat config/remote_type`

if [ "$REMOTE_TYPE" = "" ]
then
    REMOTE_TYPE="SIP_Proxy"
fi

echo "		<option value=\"$REMOTE_TYPE\">$REMOTE_TYPE</option>"

echo "		<option value=\"$REMOTE_TYPE\">--</option>"

cat << EOF
    	    	<option value="SIP_Proxy">SIP Proxy</option>
    	    	<option value="SIP_User_Agent">SIP User Agent</option>
    	    </select>
	</td>
    </tr>

    
    <tr>
    	<td colspan="4" bgcolor="#FFFFFF" td align="left" valign="top">
    	    <input type="submit" name="op" value="Submit">
	</td>
    </tr>

</table>

</form>

</body>
</html>

EOF
