/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const tCallCtlSession_cxx_Version = 
    "$Id: tCallCtlSession.cxx,v 1.8 2000/12/18 23:47:38 bko Exp $";


#include <assert.h>
#include <iostream>

#include "VLog.hxx"

#include "Call.hxx"
#include "RouterCallCtl.hxx"
#include "EvtH245TCPOpened.hxx"
#include "EvtEndSession.hxx"
#include "EvtH245Hangup.hxx"
#include "SesH245.hxx"

using namespace router;
using Vocal::Logging::VLog;


int main()
{
    VLog::init(LOG_DEBUG);
    VLog::on(LOG_DEBUG);
    VLog::on(LOG_WARNING);
    
    RouterCallCtl router;
    mte::Mediator null;
    Call call(null);
    SesH245 ses;

    EvtH245TCPOpened open(&call);
    EvtEndSession es(&router);
    ses.add(&es);
    BH245EndSession msg;
    es.setMessage(msg);
    EvtH245Hangup hup(&call);

    assert(call.getCallCtlConnection());

    cerr << "Initial state:" << endl;
    cerr << call;
    
    open.start();
    cerr << "State after open:" << endl;
    cerr << call;

    hup.start();
    cerr << "State after hangup:" << endl;
    cerr << call;

    ses.generate(msg, call.getCallCtlConnection());
    cerr << "State after end-session:" << endl;
    cerr << call;

    return 0;
}
