/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const tAddresstest_cxx_Version = 
    "$Id: tAddresstest.cxx,v 1.17 2002/02/25 05:57:17 sprajpat Exp $";


#include <iostream>
#include <string>
#include <exception>
#include <stdlib.h>
#include "cpLog.h"
#include "Data.hxx"
#include "Address.hxx"
#include "AddressToFrom.hxx"

using namespace Translator;

// TEMP CODE: 	This is a temporary work around to avoid calling
//          	gethostbyname in CapabilityMap.
//
string	    SipToH323CallSigGW_HostAddress;
//
// TEMP CODE END

Address a_address;
H323Address address;

void getAddress(const H323Address &address)
{
   int a_size = address.GetSize();
    int i;
    std::string strAddress;
    
    std::cout << std::endl;
    std::cout << "Current size of address : " << a_size << std::endl;
    
    for(i = 0; i < a_size; i++)
    {
    
    switch(address[i].GetTag())
    {
      case(H225_AliasAddress::e_url_ID):
      {
        PASN_IA5String &ia5url = (PASN_IA5String &)address[i];
    
      	strAddress = (std::string((const char*)((PString)ia5url)));
	
	std::cout << "e_url_ID : ";
        std::cout << strAddress << std::endl;
      } break;
    
      case(H225_AliasAddress::e_e164):
      {
        PASN_IA5String &ia5ph = (PASN_IA5String &)address[i];
    
      	strAddress = (std::string((const char*)((PString)ia5ph)));
	
	std::cout << "e_e164 : ";
        std::cout << strAddress << std::endl;
      } break;

      case(H225_AliasAddress::e_h323_ID):
      {
        PASN_BMPString &bmph323 = (PASN_BMPString &)address[i];
    
      	strAddress = (std::string((const char*)((PString)bmph323)));
	
	std::cout << "e_h323_ID : ";
        std::cout << strAddress << std::endl;
      } break;
    
      case(H225_AliasAddress::e_transportID):
      {
    
       H225_TransportAddress &trAddress = (H225_TransportAddress &)address[i];
       
       if(trAddress.GetTag() == H225_TransportAddress::e_ipAddress)
       {
         H225_TransportAddress_ipAddress &ipAddress = (H225_TransportAddress_ipAddress &)trAddress;
         
	 char tHost[20];
	 std::string psHost;
	 int j;
	 
	 for(j = 0; j < 4; j++)
	 {
	    sprintf(tHost, "%d", (int)ipAddress.m_ip[j]);
	    psHost += tHost;
	    if(j < 3)psHost += ".";
	 }
	 
	 int iPort = ipAddress.m_port;
	 char tPort[10];
	 
	 sprintf(tPort, "%d", iPort);
	// debug
	std::string strdispl = psHost + ":" + tPort;
	std::cout << "e_transportID : ";
	std::cout << strdispl << std::endl;
       }
      } break;

      case(H225_AliasAddress::e_email_ID):
      {
        PASN_IA5String &ia5email = (PASN_IA5String &)address[i];
    
	strAddress = (std::string((const char*)((PString)ia5email)));
	
	std::cout << "email_ID : ";
        std::cout << strAddress << std::endl;
      } break;
    
      default:std::cout << "Yaki tag" << endl; break;
    
    }
    
    }

}

void checkIPAddress()
{
   cout << endl;
   cout << "CheckIPAddress.............." << endl;

    char s_ip[] = "124.23.67.23";
    IPAddress ip_Address(s_ip, 1234);
    
    std::cout << "IP Address assigned : " 
       << ip_Address.getIPAsString() << ":" << ip_Address.getPort() << std::endl;
    
    //a_address = ip_Address; // assign (const ipAddress &)
    a_address.setPhone("1111");
    getAddress(a_address);
    Address a5_address;
    a5_address = a_address;
    
    char s1_ip[] = "123.78.56.45";
    ip_Address.setIP(s1_ip);
    
    a_address.setTransport(ip_Address);

    a_address.setPhone("1111");
    getAddress(a_address);
    if(a_address == a5_address)std::cout << "They equal !" << std::endl;
    else std::cout << "They do not equal !" << std::endl;

    char s2_ip[] = "124.56.33.5";
    ip_Address.setIP(s2_ip);
    a_address.setTransport(ip_Address);
    
    a_address.setPhone("3333");
    getAddress(a_address);
    if(a_address == a5_address)std::cout << "They equal !" << std::endl;
    else std::cout << "They do not equal !" << std::endl;

    char s3_ip[] = "99.90.2.55";
    ip_Address.setIP(s3_ip);
    a_address.setTransport(ip_Address);
    
    getAddress(a_address);
    
    ip_Address = a_address.getIPAddress();
    cout << "Here is the IPAddress we get : " << ip_Address.getIPAsString() << endl;

   cout << endl;
   cout << "End of CheckIPAddress.............." << endl;

}

void checkPhone()
{
   cout << endl;
   cout << "CheckPhone.............." << endl;
   Address a5_address;

    try
    {
      a_address.setPhone("4444");
    }
    catch (XlatorException &mS)
    {
      std::cout << mS.getDescription() << std::endl;
      exit(9);
    }
    
    address = a_address; // retreiveH323

    Address a6_address;
    a6_address = a5_address;
    cout << "before assign" << endl;
    getAddress(a6_address);
    cout << "before assign, plus that what we assign" << endl;
    getAddress(address);
    try
    {
      a6_address.setPhone(address);
    }
    catch (XlatorException &mS)
    {
      std::cout << mS.getDescription() << std::endl;
      exit(9);
    }
    cout << "after assign" << endl;
    getAddress(a6_address);
    a5_address = address;
    if(a6_address == a5_address)std::cout << "a4 & a5 equal !" << std::endl;
    else std::cout << "a4 & a5 do not equal !" << std::endl;
    
    getAddress(address);
    
    try
    {
      std::string str = a6_address.getPhone();
      cout << "Here is the phone that we get : " << str << endl;
    }
    catch (XlatorException)
    {
      cpLog(LOG_ERR, "Problems with getPhone");
      exit(9);
    }
   cout << endl;
   cout << "End of CheckPhone.............." << endl;

}

void checkUser()
{
   Address ac_address;
   cout << endl;
   cout << "CheckUser.............." << endl;
   
   try
   {
     ac_address.setUser("Vlad Zubarev");
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Problems with setUser");
   }

   getAddress(ac_address);
   ac_address = address;
   getAddress(ac_address);
   
   try
   {
     ac_address.setUser("Ian Cahoon");
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Problems with setUser");
   }
   
   getAddress(ac_address);
   
   cout << "Here is the UserID we get : " << ac_address.getUser();
   cout << endl;
   cout << "End of CheckUser.............." << endl;
   
}

void checkToFrom()
{
   cout << endl;
   cout << "CheckToFrom.............." << endl;
   
   SipFrom sipFrom;
   SipTo sipTo;
   SipAddress s_Address;
   Address ac_address;

   try
   {
     a_address.setUser("Vlad Zubarev");
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Problems with setUser");
     exit(9);
   }

   getAddress(a_address);

   try
   {
     sipFrom = AddressToFrom(a_address);
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Not a valid address");
     return;
   }
   
   Data dFrom;
   dFrom = sipFrom.encode();
   
   ac_address = a_address;
   try
   {
     ac_address.setUser("Ian Cahoon");
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Problems with setUser");
     exit(9);
   }
   
   getAddress(ac_address);
   
   try
   {
     sipTo = AddressToFrom(ac_address);
   }
   catch (XlatorException)
   {
     cpLog(LOG_ERR, "Not a valid address");
     return;
   }

   Data dTo;
   dTo = sipTo.encode();
 
   cout << "Here is From : " << dFrom.logData() << " and To : " << dTo.logData();
   cout << endl;
   cout << "End of CheckToFrom.............." << endl;
}

void checkH245Transport()
{
    cout << endl;
    cout << "CheckH245Transport.............." << endl;

    char s_ip[] = "124.23.67.23";
    IPAddress ip_Address(s_ip, 1234);
    
    Address ah_address(ip_Address);
    
    H245_UnicastAddress_iPAddress hAddress;
    hAddress = ah_address;

    Address ah1_address(hAddress);
    getAddress(ah1_address);
    
    ip_Address = ah1_address;
    cout << "Here is the IPAddress we get : " << ip_Address.getIPAsString() << endl;

    cout << endl;
    cout << "End of CheckIPAddress.............." << endl;
}

main()
{

    putenv("SIP_PARSER_STRICT_MODE=12");
    //if(getenv("SIP_PARSER_STRICT_MODE"))
      //cout << "Var : " << getenv("SIP_PARSER_STRICT_MODE") << endl;

    std::cout << "Sip address to convert : ";
    
    
    std::string s_sipAddress;
    
    std::cin >> s_sipAddress;
    Data d_sipAddress(s_sipAddress);
    
    //SipAddress sipAddress(std::string("sip:+1-23-45-67p8:vladis@12.78.56.34:7890;user=phone"));
    
    SipAddress sipAddress;
    
    try
    {
      SipAddress c_sipAddress(d_sipAddress);
      sipAddress = c_sipAddress;
    }
    
    catch(SipUrlParserException &mS)
    {
      std::cout << mS.what() << std::endl;
      cpLog(LOG_ERR, "Unusable Sip address (was not parsed by Sip Parser)");
      exit(1);
    }
    
    std::cout << "Sip address before conversion to H323: " << (sipAddress.getNameAddr()).logData() << endl;
    
    a_address = sipAddress; // assign (const SipAddress &)
    
    Address a1_address(a_address); // assign (const Address &)
    
    Address a2_address = a1_address; // operator=(const Address &)
    
    address = a1_address;  // retreiveH323
    
    a_address = address; // assign (const H323Address &)
    
    getAddress(address);
    
    sipAddress = a_address; // retreiveSip
    
    std::cout << "Sip address after conversion from H323: " 
      << (sipAddress.getNameAddr()).logData() << std::endl << std::endl;
    
    checkIPAddress();
    
    checkPhone();
    
    checkUser();
    
    checkToFrom();
    
    checkH245Transport();
    
    sipAddress = a_address; // retreiveSip
    
    std::cout << "Sip address after conversion from H323: " 
      << (sipAddress.getNameAddr()).logData() << std::endl << std::endl;
    
    exit(0);
    
    IPAddress ip_Address;
    try
    {
      ip_Address = a_address; // retreiveIP
    }
    
    catch (XlatorException &mX)
    {
      std::cout << mX.getDescription() << std::endl;
      exit(1);
    }
    
    std::cout << "IP address after conversion from H323: " 
      << ip_Address.getIPAsString() << ":" << ip_Address.getPort() << std::endl;
      
    sipAddress = a_address; // retreiveSip

    std::cout << "Sip address after conversion from H323: " << (sipAddress.getNameAddr()).logData() << std::endl;

}
