/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const tCapabilitySetTest_cxx_Version = 
    "$Id: tCapabilitySetTest.cxx,v 1.8 2000/12/18 23:48:26 bko Exp $";


#include <cstdlib>
#include <iostream>
#include "Assert.hxx"
#include "IPAddress.hxx"
#include "Address.hxx"
#include "CapabilitySetSip.hxx"
#include "CapabilitySetH323.hxx"
#include "CapabilitySetIntersect.hxx"
#include "SessionDescriptorVec.hxx"
#include "VLog.hxx"

using namespace Translator;
using Vocal::Transport::IPAddress;
using Vocal::Logging::VLog;


// TEMP CODE: 	This is a temporary work around to avoid calling
//          	gethostbyname in CapabilityMap.
//
string	    SipToH323CallSigGW_HostAddress;
//
// TEMP CODE END


#ifndef DEBUG
#define DEBUG 1
#endif

  CapabilitySetSip csSip;
  CapabilitySetH323 csH323;
  CapabilitySetIntersect csInt(csSip, csH323);

void capabilitySetAddTest(CapabilitySet &csSip)
{
  int i = 0;
  VLog	log;
  
  for(i = 1; i < 4; i++)
  {
    VDEBUG(log) << "cap to add: " << i << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(i, 0); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       exit(3);
    }
  }
  
  for(i = 11; i < 13; i++)
  {
    VDEBUG(log) << "cap to add: " << i << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(i, 0, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       exit(3);
    }
  }

    VDEBUG(log) << "cap to add: " << 1 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(1, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       exit(3);
    }

    VDEBUG(log) << "cap to add: " << 4 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(4, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    VDEBUG(log) << "cap to add: " << 5 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(5, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    VDEBUG(log) << "cap to add: " << 11 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(11, 1, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    /*
    VDEBUG(log) << "cap to add: " << 19 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(19, 0, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    VDEBUG(log) << "cap to add: " << 22 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(22, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    VDEBUG(log) << "cap to add: " << 91 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(91, 1, 2); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }

    VDEBUG(log) << "cap to add: " << 127 << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(127, 0, 2); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
    }*/

}

void capabilitySetAddTest0(CapabilitySet &csSip)
{
  int i = 0;
  VLog	log;
  
  csSip.capRecv.addCapability(1);
  csSip.capRecv.addCapability(4);
  csSip.capRecv.addCapability(2);
  
  //std::cout << std::endl << "adding caps : ";
  for(i = 11; i < 14; i++)
  {
    VDEBUG(log) << "cap to add: " << i << VDEBUG_END(log);

    try { csSip.capRecv.addCapability(i, 0, 1); }
    catch (XlatorException &mS)
    {
       VDEBUG(log) << mS.getDescription() << VDEBUG_END(log);
       exit(3);
    }

  }
  
  csSip.capRecv.addCapability(1, 1);
  csSip.capRecv.addCapability(2, 1);
  csSip.capRecv.addCapability(5, 1);
  
  csSip.capRecv.addCapability(11, 1, 1);
  csSip.capRecv.addCapability(13, 1, 1);
}

void capabilitySetAddTest1(CapabilitySet &csSip)
{
  csSip.capRecv.addCapability(1);
  csSip.capRecv.addCapability(2);
  csSip.capRecv.addCapability(3);

  csSip.capRecv.addCapability(5, 0, 1);
  csSip.capRecv.addCapability(4, 0, 1);
  
  csSip.capRecv.addCapability(7, 1, 0);
  csSip.capRecv.addCapability(6, 1, 0);
  csSip.capRecv.addCapability(5, 1, 0);

  csSip.capRecv.addCapability(6, 1, 1);
  
}

void capabilitySetAddTest2(CapabilitySet &csSip)
{
  csSip.capRecv.addCapability(5);
  /*csSip.capRecv.addCapability(4);
  csSip.capRecv.addCapability(12);
  
  csSip.capRecv.addCapability(11, 0, 1);
  csSip.capRecv.addCapability(12, 0, 1);
  csSip.capRecv.addCapability(13, 0, 1);*/

}

void capabilitySetGetTest(CapabilitySet &csSip)
{
  int i = 0, j = 0, h = 0, vecSize = 0, descrSize = 0, altSize = 0;
  VLog log;
  
  //DebugOut(!DEBUG, "Just entered GetTest");
  
  vecSize = csSip.capRecv.getCapDescrVecSize();
  if(!vecSize)
  {
    VDEBUG(log) << "Seems like this guy is empty..." << VDEBUG_END(log);
  }
  
  for(i = 0; i < csSip.capRecv.getCapDescrVecSize(); i++)
  {
    descrSize = csSip.capRecv.getCapDescrSize(i);
    //std::cout << std::endl << "descrSize : " << descrSize;

    for(j = 0; j < descrSize; j++)
    {
      altSize = csSip.capRecv.getAltCapSize(i, j);

      std::cout << std::endl << i << "." << j << " " << std::endl;
      std::cout << "      ";
      for(h = 0; h < altSize; h++)
      {
        //std::cout << "(" << h << ")";
        std::cout<< csSip.capRecv.getCapability(i, j, h) << " ";
      }
    }
  }
  
  std::cout << std::endl;

        /*i = 1; j = 0; h = 1;
	std::cout << i << "." << j << "." << h << " ";
        try
	{
	  std::cout << csSip.capRecv.getCapability(i, j, h) << std::endl;
	}
        
	catch (XlatorException &mS)
        {
          std::cout << mS.getDescription() << std::endl;
	  return;
        }*/

}

void sessionDescriptorTest()
{
  SessionDescriptorVec sdVec;
  IPAddress ipAddress("129.78.56.45", 4509);
  VLog	log;
  
  
  cout << "sessonDescriptorTest ------------------- BEGIN " << endl;
  Address address(ipAddress);
  //address = ipAddress;
  
  int i = 0, j = 0, vecSize = 0, descrSize = 0;
  
  for(i = 0; i < 9; i++)
  {
    //DebugOut(!DEBUG, i);
    VDEBUG(log) << ipAddress.getIPAsString() << VDEBUG_END(log);
    
    try { sdVec.setCapability(i, 0, i); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       exit(3);
    }

    try { sdVec.transportIDSip.setRTPAddr(address, 0, i); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       exit(3);
    }

  }

    try { sdVec.transportIDSip.setRTPAddr(address, 1, 0); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }

    try { sdVec.transportIDSip.setRTPAddr(address, 1, 2); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }

    try { sdVec.transportIDSip.setRTPAddr(address, 1, 15); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }
  
    ///
    ///
    try { sdVec.setCapability(89, 1, 0); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }

    try { sdVec.setCapability(98, 1, 1); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }

    try { sdVec.setCapability(101, 1, 3); }
    catch (XlatorException &mS)
    {
       std::cout << mS.getDescription() << std::endl;
       //exit(3);
    }

  vecSize = sdVec.transportIDSip.getTranspIDVecSize();
  //std::cout << "vecSize : " << vecSize << std::endl;
    
  for(i = 0; i < sdVec.transportIDSip.getTranspIDVecSize(); i++)
  {
    try
    { 
      descrSize = sdVec.transportIDSip.getTranspIDSetSize(i);
      cout << "for trSet " << i << " descrSize is " << descrSize << endl;
    }
    
    catch (XlatorException &mS)
    {
      std::cout << mS.getDescription() << std::endl;
      exit(1);
    }

    //std::cout << "descrSize : " << descrSize << std::endl;

    for(j = 0; j < descrSize; j++)
    {
        std::cout << i << "." << j << " ";
        ipAddress = sdVec.transportIDSip.getRTPAddr(i, j);
	std::cout << ipAddress.getIPAsString() << ":" << ipAddress.getPort() << std::endl;
    }
  }

  vecSize = sdVec.getSessionDescrVecSize();
  //std::cout << "vecSize : " << vecSize << std::endl;
    
  for(i = 0; i < sdVec.getSessionDescrVecSize(); i++)
  {
    try { descrSize = sdVec.getSessionDescrSetSize(i); }
    
    catch (XlatorException &mS)
    {
      std::cout << mS.getDescription() << std::endl;
      exit(1);
    }

    //std::cout << "descrSize : " << descrSize << std::endl;

    for(j = 0; j < descrSize; j++)
    {
        std::cout << i << "." << j << " ";
	std::cout << sdVec.getCapability(i, j) << std::endl;
    }
  }

  cout << "sessonDescriptorTest END -------------------" << endl;

}

void intersectionTest()
{
  std::cout << std::endl << "intersectionTest BEGIN ---------------------" << std::endl;

  try
  {
    csInt.makeIntersect(false);
  }
  catch (XlatorException &mS)
  {
    std::cout << mS.getDescription() << std::endl;
    exit(99);
  }
  
  std::cout << std::endl << "intersectionTest END ---------------------" << std::endl;
}

main()
{
  capabilitySetAddTest(csSip);

  capabilitySetAddTest0(csH323);
  std::cout << std::endl << "This is Sip capability set" << endl;

  capabilitySetGetTest(csSip);
  std::cout << std::endl << "This is H323 capability set" << endl;

  capabilitySetGetTest(csH323);
  
  intersectionTest();
  capabilitySetGetTest(csInt);
  //sessionDescriptorTest();
  
}
